
{$ifdef INTERFACE}
function NSSTR (inString: PChar): NSString; overload;
function NSSTR (inString: string): NSString; overload;
procedure NSShow (obj: id);
procedure WriteLog (inString: string);
	
function NSMakeRange (loc: NSUInteger; len: NSUInteger): NSRange;
function NSMaxRange (range: NSRange): NSUInteger;
function NSLocationInRange (loc: NSUInteger; range: NSRange): boolean;
function NSEqualRanges (range1, range2: NSRange): boolean;
	
{$endif}

{$ifdef IMPLEMENTATION}
function NSSTR (inString: PChar): NSString;
begin
  result := NSString(CFSTR(inString));
end;

function NSSTR (inString: string): NSString;
begin
	if inString <> '' then
  	result := NSString(CFSTR(@inString[1]))
	else
		result := NSString(CFSTR(''));
end;

procedure WriteLog (inString: string);
begin
  NSLog(NSSTR(inString), NSSTR('@'));
end;

procedure NSShow (obj: id);
begin
	NSLog(obj.description, NSSTR('@'));
end;

function NSMakeRange (loc: NSUInteger; len: NSUInteger): NSRange;
begin
 result.location := loc;
 result.length := len;
end;

function NSMaxRange (range: NSRange): NSUInteger;
begin
 result := range.location + range.length;
end;

function NSLocationInRange (loc: NSUInteger; range: NSRange): boolean;
begin
 if (loc <= range.location + range.length) and (loc >= range.location) then
  result := true
 else
  result := false;
end;

function NSEqualRanges (range1, range2: NSRange): boolean;
begin
 if (range1.location = range2.location) and (range1.length = range2.length) then
  result := true
 else
  result := false;
end;

{$endif}
