{ Parsed from Foundation.framework (iPhoneOS5.0) NSCalendar.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSEraCalendarUnit = kCFCalendarUnitEra;
  NSYearCalendarUnit = kCFCalendarUnitYear;
  NSMonthCalendarUnit = kCFCalendarUnitMonth;
  NSDayCalendarUnit = kCFCalendarUnitDay;
  NSHourCalendarUnit = kCFCalendarUnitHour;
  NSMinuteCalendarUnit = kCFCalendarUnitMinute;
  NSSecondCalendarUnit = kCFCalendarUnitSecond;
  NSWeekCalendarUnit = kCFCalendarUnitWeek;
  NSWeekdayCalendarUnit = kCFCalendarUnitWeekday;
  NSWeekdayOrdinalCalendarUnit = kCFCalendarUnitWeekdayOrdinal;
  {$if (MAC_OS_X_VERSION_10_6 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSQuarterCalendarUnit = kCFCalendarUnitQuarter;
  {$endif}
  {$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_5_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSWeekOfMonthCalendarUnit = kCFCalendarUnitWeekOfMonth;
  NSWeekOfYearCalendarUnit = kCFCalendarUnitWeekOfYear;
  NSYearForWeekOfYearCalendarUnit = kCFCalendarUnitYearForWeekOfYear;
  {$endif}
  {$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSCalendarCalendarUnit = 1 shl 20;
  NSTimeZoneCalendarUnit = 1 shl 21;
  {$endif}

type
  NSCalendarUnit = NSUInteger;
  NSCalendarUnitPtr = ^NSCalendarUnit;
{$endif}

{$ifdef CLASSES}

type
  NSCalendar = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  public
    class function currentCalendar: id; message 'currentCalendar';
    class function autoupdatingCurrentCalendar: id; message 'autoupdatingCurrentCalendar';
    function initWithCalendarIdentifier (ident: NSString): id; message 'initWithCalendarIdentifier:';
    function calendarIdentifier: NSString; message 'calendarIdentifier';
    procedure setLocale (locale: NSLocale); message 'setLocale:';
    function locale: NSLocale; message 'locale';
    procedure setTimeZone (tz: NSTimeZone); message 'setTimeZone:';
    function timeZone: NSTimeZone; message 'timeZone';
    procedure setFirstWeekday (weekday: NSUInteger); message 'setFirstWeekday:';
    function firstWeekday: NSUInteger; message 'firstWeekday';
    procedure setMinimumDaysInFirstWeek (mdw: NSUInteger); message 'setMinimumDaysInFirstWeek:';
    function minimumDaysInFirstWeek: NSUInteger; message 'minimumDaysInFirstWeek';
    function minimumRangeOfUnit (unit_: NSCalendarUnit): NSRange; message 'minimumRangeOfUnit:';
    function maximumRangeOfUnit (unit_: NSCalendarUnit): NSRange; message 'maximumRangeOfUnit:';
    function rangeOfUnit_inUnit_forDate (smaller: NSCalendarUnit; larger: NSCalendarUnit; date: NSDate): NSRange; message 'rangeOfUnit:inUnit:forDate:';
    function ordinalityOfUnit_inUnit_forDate (smaller: NSCalendarUnit; larger: NSCalendarUnit; date: NSDate): NSUInteger; message 'ordinalityOfUnit:inUnit:forDate:';
    function rangeOfUnit_startDate_interval_forDate (unit_: NSCalendarUnit; datep: NSDatePtr; tip: NSTimeInterval; date: NSDate): boolean; message 'rangeOfUnit:startDate:interval:forDate:';
    function dateFromComponents (comps: NSDateComponents): NSDate; message 'dateFromComponents:';
    function components_fromDate (unitFlags: NSUInteger; date: NSDate): NSDateComponents; message 'components:fromDate:';
    function dateByAddingComponents_toDate_options (comps: NSDateComponents; date: NSDate; opts: NSUInteger): NSDate; message 'dateByAddingComponents:toDate:options:';
    function components_fromDate_toDate_options (unitFlags: NSUInteger; startingDate: NSDate; resultDate: NSDate; opts: NSUInteger): NSDateComponents; message 'components:fromDate:toDate:options:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;
{$endif}

{$ifdef TYPES}
const
  NSWrapCalendarComponents = kCFCalendarComponentsWrap;
const
  NSUndefinedDateComponent = NSIntegerMax;
{$endif}

{$ifdef CLASSES}

type
  NSDateComponents = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  public
    function calendar: NSCalendar; message 'calendar';
    function timeZone: NSTimeZone; message 'timeZone';
    function era: NSInteger; message 'era';
    function year: NSInteger; message 'year';
    function month: NSInteger; message 'month';
    function day: NSInteger; message 'day';
    function hour: NSInteger; message 'hour';
    function minute: NSInteger; message 'minute';
    function second: NSInteger; message 'second';
    function week: NSInteger; message 'week';
    function weekday: NSInteger; message 'weekday';
    function weekdayOrdinal: NSInteger; message 'weekdayOrdinal';
    function quarter: NSInteger; message 'quarter';
    function weekOfMonth: NSInteger; message 'weekOfMonth';
    function weekOfYear: NSInteger; message 'weekOfYear';
    function yearForWeekOfYear: NSInteger; message 'yearForWeekOfYear';
    procedure setCalendar (cal: NSCalendar); message 'setCalendar:';
    procedure setTimeZone (tz: NSTimeZone); message 'setTimeZone:';
    procedure setEra (v: NSInteger); message 'setEra:';
    procedure setYear (v: NSInteger); message 'setYear:';
    procedure setMonth (v: NSInteger); message 'setMonth:';
    procedure setDay (v: NSInteger); message 'setDay:';
    procedure setHour (v: NSInteger); message 'setHour:';
    procedure setMinute (v: NSInteger); message 'setMinute:';
    procedure setSecond (v: NSInteger); message 'setSecond:';
    procedure setWeek (v: NSInteger); message 'setWeek:';
    procedure setWeekday (v: NSInteger); message 'setWeekday:';
    procedure setWeekdayOrdinal (v: NSInteger); message 'setWeekdayOrdinal:';
    procedure setQuarter (v: NSInteger); message 'setQuarter:';
    procedure setWeekOfMonth (w: NSInteger); message 'setWeekOfMonth:';
    procedure setWeekOfYear (w: NSInteger); message 'setWeekOfYear:';
    procedure setYearForWeekOfYear (y: NSInteger); message 'setYearForWeekOfYear:';
    function date: NSDate; message 'date';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;
{$endif}

