{ Parsed from Foundation.framework (iPhoneOS5.0) NSData.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSDataReadingMappedIfSafe = 1 shl 0;
  NSDataReadingUncached = 1 shl 1;
  {$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_5_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSDataReadingMappedAlways = 1 shl 3;
  {$endif}

type
  NSDataReadingOptions = NSUInteger;
  NSDataReadingOptionsPtr = ^NSDataReadingOptions;

const
  NSDataWritingAtomic = 1 shl 0;
  {$if (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSDataWritingFileProtectionNone = $10000000;
  NSDataWritingFileProtectionComplete = $20000000;
  {$if (__IPHONE_5_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSDataWritingFileProtectionCompleteUnlessOpen = $30000000;
  NSDataWritingFileProtectionCompleteUntilFirstUserAuthentication = $40000000;
  {$endif}
  NSDataWritingFileProtectionMask = $f0000000;
  {$endif}

type
  NSDataWritingOptions = NSUInteger;
  NSDataWritingOptionsPtr = ^NSDataWritingOptions;

const
  NSDataReadingMapped = NSDataReadingMappedIfSafe;
  NSMappedRead = NSDataReadingMapped;
  NSUncachedRead = NSDataReadingUncached;
const
  NSAtomicWrite = NSDataWritingAtomic;
{$endif}

{$if (MAC_OS_X_VERSION_10_6 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSDataSearchBackwards = 1 shl 0;
  NSDataSearchAnchored = 1 shl 1;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSDataSearchOptions = NSUInteger;
  NSDataSearchOptionsPtr = ^NSDataSearchOptions;
{$endif}

{$ifdef CLASSES}

type
  NSData = objcclass external (NSObject, NSCopyingProtocol, NSMutableCopyingProtocol, NSCodingProtocol)
  public
    function length: NSUInteger; message 'length';
    function bytes: pointer; message 'bytes';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
    function mutableCopyWithZone (zone: NSZone): id; message 'mutableCopyWithZone:';
  end;


type
  NSData_NSExtendedData = objccategory external name 'NSExtendedData' (NSData)
    function description: NSString; message 'description';
    procedure getBytes_length (buffer: pointer; length_: NSUInteger); message 'getBytes:length:';
    procedure getBytes_range (buffer: pointer; range: NSRange); message 'getBytes:range:';
    function isEqualToData (other: NSData): boolean; message 'isEqualToData:';
    function subdataWithRange (range: NSRange): NSData; message 'subdataWithRange:';
    function writeToFile_atomically (path: NSString; useAuxiliaryFile: boolean): boolean; message 'writeToFile:atomically:';
    function writeToURL_atomically (url: NSURL; atomically: boolean): boolean; message 'writeToURL:atomically:';
    function writeToFile_options_error (path: NSString; writeOptionsMask: NSDataWritingOptions; errorPtr: NSErrorPtr): boolean; message 'writeToFile:options:error:';
    function writeToURL_options_error (url: NSURL; writeOptionsMask: NSDataWritingOptions; errorPtr: NSErrorPtr): boolean; message 'writeToURL:options:error:';
    function rangeOfData_options_range (dataToFind: NSData; mask: NSDataSearchOptions; searchRange: NSRange): NSRange; message 'rangeOfData:options:range:';
  end;

type
  NSData_NSDataCreation = objccategory external name 'NSDataCreation' (NSData)
    class function data: id; message 'data';
    class function dataWithBytes_length (bytes_: pointer; length_: NSUInteger): id; message 'dataWithBytes:length:';
    class function dataWithBytesNoCopy_length (bytes_: pointer; length_: NSUInteger): id; message 'dataWithBytesNoCopy:length:';
    class function dataWithBytesNoCopy_length_freeWhenDone (bytes_: pointer; length_: NSUInteger; b: boolean): id; message 'dataWithBytesNoCopy:length:freeWhenDone:';
    class function dataWithContentsOfFile_options_error (path: NSString; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'dataWithContentsOfFile:options:error:';
    class function dataWithContentsOfURL_options_error (url: NSURL; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'dataWithContentsOfURL:options:error:';
    class function dataWithContentsOfFile (path: NSString): id; message 'dataWithContentsOfFile:';
    class function dataWithContentsOfURL (url: NSURL): id; message 'dataWithContentsOfURL:';
    function initWithBytes_length (bytes_: pointer; length_: NSUInteger): id; message 'initWithBytes:length:';
    function initWithBytesNoCopy_length (bytes_: pointer; length_: NSUInteger): id; message 'initWithBytesNoCopy:length:';
    function initWithBytesNoCopy_length_freeWhenDone (bytes_: pointer; length_: NSUInteger; b: boolean): id; message 'initWithBytesNoCopy:length:freeWhenDone:';
    function initWithContentsOfFile_options_error (path: NSString; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'initWithContentsOfFile:options:error:';
    function initWithContentsOfURL_options_error (url: NSURL; readOptionsMask: NSDataReadingOptions; errorPtr: NSErrorPtr): id; message 'initWithContentsOfURL:options:error:';
    function initWithContentsOfFile (path: NSString): id; message 'initWithContentsOfFile:';
    function initWithContentsOfURL (url: NSURL): id; message 'initWithContentsOfURL:';
    function initWithData (data_: NSData): id; message 'initWithData:';
    class function dataWithData (data_: NSData): id; message 'dataWithData:';
  end;

type
  NSData_NSDeprecated = objccategory external name 'NSDeprecated' (NSData)
    procedure getBytes (buffer: pointer); message 'getBytes:';
    class function dataWithContentsOfMappedFile (path: NSString): id; message 'dataWithContentsOfMappedFile:';
    function initWithContentsOfMappedFile (path: NSString): id; message 'initWithContentsOfMappedFile:';
  end;


type
  NSMutableData = objcclass external (NSData)
  public
    function mutableBytes: pointer; message 'mutableBytes';
    procedure setLength (length_: NSUInteger); message 'setLength:';
  end;


type
  NSMutableData_NSExtendedMutableData = objccategory external name 'NSExtendedMutableData' (NSMutableData)
    procedure appendBytes_length (bytes_: pointer; length_: NSUInteger); message 'appendBytes:length:';
    procedure appendData (other: NSData); message 'appendData:';
    procedure increaseLengthBy (extraLength: NSUInteger); message 'increaseLengthBy:';
    procedure replaceBytesInRange_withBytes (range: NSRange; bytes_: pointer); message 'replaceBytesInRange:withBytes:';
    procedure resetBytesInRange (range: NSRange); message 'resetBytesInRange:';
    procedure setData (data_: NSData); message 'setData:';
    procedure replaceBytesInRange_withBytes_length (range: NSRange; replacementBytes: pointer; replacementLength: NSUInteger); message 'replaceBytesInRange:withBytes:length:';
  end;

type
  NSMutableData_NSMutableDataCreation = objccategory external name 'NSMutableDataCreation' (NSMutableData)
    class function dataWithCapacity (aNumItems: NSUInteger): id; message 'dataWithCapacity:';
    class function dataWithLength (length_: NSUInteger): id; message 'dataWithLength:';
    function initWithCapacity (capacity: NSUInteger): id; message 'initWithCapacity:';
    function initWithLength (length_: NSUInteger): id; message 'initWithLength:';
  end;


type
  NSPurgeableData = objcclass external (NSMutableData, NSDiscardableContentProtocol)
  private
    _length: NSUInteger;
    _accessCount: cint32;
    _private: array[0..(32) - 1] of cuint8;
    _reserved: pointer;

    { Adopted protocols }
    function beginContentAccess: boolean; message 'beginContentAccess';
    function isContentDiscarded: boolean; message 'isContentDiscarded';
    procedure discardContentIfPossible; message 'discardContentIfPossible';
    procedure endContentAccess; message 'endContentAccess';
  end;
{$endif}

