{ Parsed from Foundation.framework (iPhoneOS5.0) NSException.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef EXTERNAL_SYMBOLS}
var
  NSGenericException: NSString; cvar; external;
  NSRangeException: NSString; cvar; external;
  NSInvalidArgumentException: NSString; cvar; external;
  NSInternalInconsistencyException: NSString; cvar; external;
  NSMallocException: NSString; cvar; external;
  NSObjectInaccessibleException: NSString; cvar; external;
  NSObjectNotAvailableException: NSString; cvar; external;
  NSDestinationInvalidException: NSString; cvar; external;
  NSPortTimeoutException: NSString; cvar; external;
  NSInvalidSendPortException: NSString; cvar; external;
  NSInvalidReceivePortException: NSString; cvar; external;
  NSPortSendException: NSString; cvar; external;
  NSPortReceiveException: NSString; cvar; external;
  NSOldStyleException: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSException = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  private
    name: NSString;
    reason: NSString;
    userInfo: NSDictionary;
    reserved: id;
  public
    class function exceptionWithName_reason_userInfo (name_: NSString; reason_: NSString; userInfo_: NSDictionary): NSException; message 'exceptionWithName:reason:userInfo:';
    function initWithName_reason_userInfo (aName: NSString; aReason: NSString; aUserInfo: NSDictionary): id; message 'initWithName:reason:userInfo:';
    function name_: NSString; message 'name';
    function reason_: NSString; message 'reason';
    function userInfo_: NSDictionary; message 'userInfo';
    function callStackReturnAddresses: NSArray; message 'callStackReturnAddresses';
    function callStackSymbols: NSArray; message 'callStackSymbols';
    procedure raise_; message 'raise';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSException_NSExceptionRaisingConveniences = objccategory external name 'NSExceptionRaisingConveniences' (NSException)
    class procedure raise_format (name__: NSString; format: NSString); varargs; message 'raise:format:';
    class procedure raise_format_arguments (name__: NSString; format: NSString; argList: va_list); message 'raise:format:arguments:';
  end;
{$endif}

{$ifdef TYPES}
type
  NSUncaughtExceptionHandler = function (exception: NSException): pointer; cdecl;
{$endif}

{$ifdef FUNCTIONS}
function NSGetUncaughtExceptionHandler: NSUncaughtExceptionHandler; cdecl; external;
function NSSetUncaughtExceptionHandler(param1: NSUncaughtExceptionHandler): pointer; cdecl; external;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSAssertionHandlerKey: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSAssertionHandler = objcclass external (NSObject)
  private
    _reserved: pointer;
  public
    class function currentHandler: NSAssertionHandler; message 'currentHandler';
    procedure handleFailureInMethod_object_file_lineNumber_description (selector: SEL; object_: id; fileName: NSString; line: NSInteger; format: NSString); varargs; message 'handleFailureInMethod:object:file:lineNumber:description:';
    procedure handleFailureInFunction_file_lineNumber_description (functionName: NSString; fileName: NSString; line: NSInteger; format: NSString); varargs; message 'handleFailureInFunction:file:lineNumber:description:';
  end;
{$endif}

