{ Parsed from Foundation.framework (iPhoneOS5.0) NSExpression.h }
{ Created on Tue Feb 7 7:54:46 2012 }


{ Types from NSExpression }
{$ifdef TYPES}


{$endif}

{$ifdef TYPES}
const
  NSConstantValueExpressionType = 0;
  NSEvaluatedObjectExpressionType = 1;
  NSVariableExpressionType = 2;
  NSKeyPathExpressionType = 3;
  NSFunctionExpressionType = 4;
  {$if (MAC_OS_X_VERSION_10_5 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_3_0 <=  __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSUnionSetExpressionType = 5;
  NSIntersectSetExpressionType = 6;
  NSMinusSetExpressionType = 7;
  NSSubqueryExpressionType = 13;
  NSAggregateExpressionType = 14;
  {$endif}
  {$if defined(NS_BLOCKS_AVAILABLE)}
  NSBlockExpressionType = 19;
  {$endif}

type
  NSExpressionType = NSUInteger;
  NSExpressionTypePtr = ^NSExpressionType;
{$endif}

{$ifdef CLASSES}

type
  NSExpression = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol)
  private
    _reserved: pointer;
    _expressionType: NSExpressionType;
  public
    class function expressionWithFormat_argumentArray (expressionFormat: NSString; arguments: NSArray): NSExpression; message 'expressionWithFormat:argumentArray:';
    class function expressionWithFormat (expressionFormat: NSString): NSExpression; varargs; message 'expressionWithFormat:';
    class function expressionWithFormat_arguments (expressionFormat: NSString; argList: va_list): NSExpression; message 'expressionWithFormat:arguments:';
    class function expressionForConstantValue (obj: id): NSExpression; message 'expressionForConstantValue:';
    class function expressionForEvaluatedObject: NSExpression; message 'expressionForEvaluatedObject';
    class function expressionForVariable (string_: NSString): NSExpression; message 'expressionForVariable:';
    class function expressionForKeyPath (keyPath: NSString): NSExpression; message 'expressionForKeyPath:';
    class function expressionForFunction_arguments (name: NSString; parameters: NSArray): NSExpression; message 'expressionForFunction:arguments:';
    class function expressionForAggregate (subexpressions: NSArray): NSExpression; message 'expressionForAggregate:';
    class function expressionForUnionSet_with (left: NSExpression; right: NSExpression): NSExpression; message 'expressionForUnionSet:with:';
    class function expressionForIntersectSet_with (left: NSExpression; right: NSExpression): NSExpression; message 'expressionForIntersectSet:with:';
    class function expressionForMinusSet_with (left: NSExpression; right: NSExpression): NSExpression; message 'expressionForMinusSet:with:';
    class function expressionForSubquery_usingIteratorVariable_predicate (expression: NSExpression; variable: NSString; predicate: id): NSExpression; message 'expressionForSubquery:usingIteratorVariable:predicate:';
    class function expressionForFunction_selectorName_arguments (target: NSExpression; name: NSString; parameters: NSArray): NSExpression; message 'expressionForFunction:selectorName:arguments:';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    class function expressionForBlock_arguments (block: OpaqueCBlock; arguments: NSArray): NSExpression; message 'expressionForBlock:arguments:';
    {$endif}
    function initWithExpressionType (type_: NSExpressionType): id; message 'initWithExpressionType:';
    function expressionType: NSExpressionType; message 'expressionType';
    function constantValue: id; message 'constantValue';
    function keyPath: NSString; message 'keyPath';
    function function_: NSString; message 'function';
    function variable: NSString; message 'variable';
    function operand: NSExpression; message 'operand';
    function arguments: NSArray; message 'arguments';
    function collection: id; message 'collection';
    function predicate: NSPredicate; message 'predicate';
    function leftExpression: NSExpression; message 'leftExpression';
    function rightExpression: NSExpression; message 'rightExpression';
    {$if defined(NS_BLOCKS_AVAILABLE)}
    function (id, NSArray *, NSMutableDictionary *))expressionBlock: id (^; message '(id, NSArray *, NSMutableDictionary *))expressionBlock';
    {$endif}
    function expressionValueWithObject_context (object_: id; context: NSMutableDictionary): id; message 'expressionValueWithObject:context:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;
{$endif}

