{ Parsed from Foundation.framework (iPhoneOS5.0) NSKeyValueObserving.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSKeyValueObservingOptionNew = $01;
  NSKeyValueObservingOptionOld = $02;
  {$if (MAC_OS_X_VERSION_10_5 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_2_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSKeyValueObservingOptionInitial = $04;
  NSKeyValueObservingOptionPrior = $08;
  {$endif}

type
  NSKeyValueObservingOptions = NSUInteger;
  NSKeyValueObservingOptionsPtr = ^NSKeyValueObservingOptions;

const
  NSKeyValueChangeSetting = 1;
  NSKeyValueChangeInsertion = 2;
  NSKeyValueChangeRemoval = 3;
  NSKeyValueChangeReplacement = 4;

type
  NSKeyValueChange = NSUInteger;
  NSKeyValueChangePtr = ^NSKeyValueChange;

const
  NSKeyValueUnionSetMutation = 1;
  NSKeyValueMinusSetMutation = 2;
  NSKeyValueIntersectSetMutation = 3;
  NSKeyValueSetSetMutation = 4;

type
  NSKeyValueSetMutationKind = NSUInteger;
  NSKeyValueSetMutationKindPtr = ^NSKeyValueSetMutationKind;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSKeyValueChangeKindKey: NSString; cvar; external;
  NSKeyValueChangeNewKey: NSString; cvar; external;
  NSKeyValueChangeOldKey: NSString; cvar; external;
  NSKeyValueChangeIndexesKey: NSString; cvar; external;
  NSKeyValueChangeNotificationIsPriorKey: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSObject_NSKeyValueObserving = objccategory external name 'NSKeyValueObserving' (NSObject)
    procedure observeValueForKeyPath_ofObject_change_context (keyPath: NSString; object_: id; change: NSDictionary; context: pointer); message 'observeValueForKeyPath:ofObject:change:context:';
  end;

type
  NSObject_NSKeyValueObserverRegistration = objccategory external name 'NSKeyValueObserverRegistration' (NSObject)
    procedure addObserver_forKeyPath_options_context (observer: NSObject; keyPath: NSString; options: NSKeyValueObservingOptions; context: pointer); message 'addObserver:forKeyPath:options:context:';
    procedure removeObserver_forKeyPath_context (observer: NSObject; keyPath: NSString; context: pointer); message 'removeObserver:forKeyPath:context:';
    procedure removeObserver_forKeyPath (observer: NSObject; keyPath: NSString); message 'removeObserver:forKeyPath:';
  end;

type
  NSArray_NSKeyValueObserverRegistration = objccategory external name 'NSKeyValueObserverRegistration' (NSArray)
    procedure addObserver_toObjectsAtIndexes_forKeyPath_options_context (observer: NSObject; indexes: NSIndexSet; keyPath: NSString; options: NSKeyValueObservingOptions; context: pointer); message 'addObserver:toObjectsAtIndexes:forKeyPath:options:context:';
    procedure removeObserver_fromObjectsAtIndexes_forKeyPath_context (observer: NSObject; indexes: NSIndexSet; keyPath: NSString; context: pointer); message 'removeObserver:fromObjectsAtIndexes:forKeyPath:context:';
    procedure removeObserver_fromObjectsAtIndexes_forKeyPath (observer: NSObject; indexes: NSIndexSet; keyPath: NSString); message 'removeObserver:fromObjectsAtIndexes:forKeyPath:';
    procedure addObserver_forKeyPath_options_context_ (observer: NSObject; keyPath: NSString; options: NSKeyValueObservingOptions; context: pointer); message 'addObserver:forKeyPath:options:context:';
    procedure removeObserver_forKeyPath_context_ (observer: NSObject; keyPath: NSString; context: pointer); message 'removeObserver:forKeyPath:context:';
    procedure removeObserver_forKeyPath_ (observer: NSObject; keyPath: NSString); message 'removeObserver:forKeyPath:';
  end;

type
  NSOrderedSet_NSKeyValueObserverRegistration = objccategory external name 'NSKeyValueObserverRegistration' (NSOrderedSet)
    procedure addObserver_forKeyPath_options_context_ (observer: NSObject; keyPath: NSString; options: NSKeyValueObservingOptions; context: pointer); message 'addObserver:forKeyPath:options:context:';
    procedure removeObserver_forKeyPath_context_ (observer: NSObject; keyPath: NSString; context: pointer); message 'removeObserver:forKeyPath:context:';
    procedure removeObserver_forKeyPath_ (observer: NSObject; keyPath: NSString); message 'removeObserver:forKeyPath:';
  end;

type
  NSSet_NSKeyValueObserverRegistration = objccategory external name 'NSKeyValueObserverRegistration' (NSSet)
    procedure addObserver_forKeyPath_options_context_ (observer: NSObject; keyPath: NSString; options: NSKeyValueObservingOptions; context: pointer); message 'addObserver:forKeyPath:options:context:';
    procedure removeObserver_forKeyPath_context_ (observer: NSObject; keyPath: NSString; context: pointer); message 'removeObserver:forKeyPath:context:';
    procedure removeObserver_forKeyPath_ (observer: NSObject; keyPath: NSString); message 'removeObserver:forKeyPath:';
  end;

type
  NSObject_NSKeyValueObserverNotification = objccategory external name 'NSKeyValueObserverNotification' (NSObject)
    procedure willChangeValueForKey (key: NSString); message 'willChangeValueForKey:';
    procedure didChangeValueForKey (key: NSString); message 'didChangeValueForKey:';
    procedure willChange_valuesAtIndexes_forKey (changeKind: NSKeyValueChange; indexes: NSIndexSet; key: NSString); message 'willChange:valuesAtIndexes:forKey:';
    procedure didChange_valuesAtIndexes_forKey (changeKind: NSKeyValueChange; indexes: NSIndexSet; key: NSString); message 'didChange:valuesAtIndexes:forKey:';
    procedure willChangeValueForKey_withSetMutation_usingObjects (key: NSString; mutationKind: NSKeyValueSetMutationKind; objects: NSSet); message 'willChangeValueForKey:withSetMutation:usingObjects:';
    procedure didChangeValueForKey_withSetMutation_usingObjects (key: NSString; mutationKind: NSKeyValueSetMutationKind; objects: NSSet); message 'didChangeValueForKey:withSetMutation:usingObjects:';
  end;

type
  NSObject_NSKeyValueObservingCustomization = objccategory external name 'NSKeyValueObservingCustomization' (NSObject)
    class function keyPathsForValuesAffectingValueForKey (key: NSString): NSSet; message 'keyPathsForValuesAffectingValueForKey:';
    class function automaticallyNotifiesObserversForKey (key: NSString): boolean; message 'automaticallyNotifiesObserversForKey:';
    procedure setObservationInfo (observationInfo: pointer); message 'setObservationInfo:';
    function observationInfo: pointer; message 'observationInfo';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not(defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSObject_NSDeprecatedKeyValueObservingCustomization = objccategory external name 'NSDeprecatedKeyValueObservingCustomization' (NSObject)
    class procedure setKeys_triggerChangeNotificationsForDependentKey (keys: NSArray; dependentKey: NSString); message 'setKeys:triggerChangeNotificationsForDependentKey:';
  end;
{$endif}

{$endif}
