{ Parsed from Foundation.framework (iPhoneOS5.0) NSLocale.h }
{ Created on Tue Feb 7 7:54:46 2012 }


{ Types from NSLocale_NSLocaleGeneralInfo }
{$ifdef TYPES}

const
  NSLocaleLanguageDirectionUnknown = kCFLocaleLanguageDirectionUnknown;
  NSLocaleLanguageDirectionLeftToRight = kCFLocaleLanguageDirectionLeftToRight;
  NSLocaleLanguageDirectionRightToLeft = kCFLocaleLanguageDirectionRightToLeft;
  NSLocaleLanguageDirectionTopToBottom = kCFLocaleLanguageDirectionTopToBottom;
  NSLocaleLanguageDirectionBottomToTop = kCFLocaleLanguageDirectionBottomToTop;

type
  NSLocaleLanguageDirection = NSUInteger;
type
  NSLocaleLanguageDirectionPtr = ^NSLocaleLanguageDirection;
{$endif}

{$ifdef CLASSES}

type
  NSLocale = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  public
    function objectForKey (key: id): id; message 'objectForKey:';
    function displayNameForKey_value (key: id; value: id): NSString; message 'displayNameForKey:value:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSLocale_NSExtendedLocale = objccategory external name 'NSExtendedLocale' (NSLocale)
    function localeIdentifier: NSString; message 'localeIdentifier';
  end;

type
  NSLocale_NSLocaleCreation = objccategory external name 'NSLocaleCreation' (NSLocale)
    class function systemLocale: id; message 'systemLocale';
    class function currentLocale: id; message 'currentLocale';
    class function autoupdatingCurrentLocale: id; message 'autoupdatingCurrentLocale';
    function initWithLocaleIdentifier (string_: NSString): id; message 'initWithLocaleIdentifier:';
  end;

type
  NSLocale_NSLocaleGeneralInfo = objccategory external name 'NSLocaleGeneralInfo' (NSLocale)
    class function availableLocaleIdentifiers: NSArray; message 'availableLocaleIdentifiers';
    class function ISOLanguageCodes: NSArray; message 'ISOLanguageCodes';
    class function ISOCountryCodes: NSArray; message 'ISOCountryCodes';
    class function ISOCurrencyCodes: NSArray; message 'ISOCurrencyCodes';
    class function commonISOCurrencyCodes: NSArray; message 'commonISOCurrencyCodes';
    class function preferredLanguages: NSArray; message 'preferredLanguages';
    class function componentsFromLocaleIdentifier (string_: NSString): NSDictionary; message 'componentsFromLocaleIdentifier:';
    class function localeIdentifierFromComponents (dict: NSDictionary): NSString; message 'localeIdentifierFromComponents:';
    class function canonicalLocaleIdentifierFromString (string_: NSString): NSString; message 'canonicalLocaleIdentifierFromString:';
    class function canonicalLanguageIdentifierFromString (string_: NSString): NSString; message 'canonicalLanguageIdentifierFromString:';
    class function localeIdentifierFromWindowsLocaleCode (lcid: cuint32): NSString; message 'localeIdentifierFromWindowsLocaleCode:';
    class function windowsLocaleCodeFromLocaleIdentifier (localeIdentifier: NSString): cuint32; message 'windowsLocaleCodeFromLocaleIdentifier:';
    class function characterDirectionForLanguage (isoLangCode: NSString): NSLocaleLanguageDirection; message 'characterDirectionForLanguage:';
    class function lineDirectionForLanguage (isoLangCode: NSString): NSLocaleLanguageDirection; message 'lineDirectionForLanguage:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSCurrentLocaleDidChangeNotification: NSString; cvar; external;
  NSLocaleIdentifier: NSString; cvar; external;
  NSLocaleLanguageCode: NSString; cvar; external;
  NSLocaleCountryCode: NSString; cvar; external;
  NSLocaleScriptCode: NSString; cvar; external;
  NSLocaleVariantCode: NSString; cvar; external;
  NSLocaleExemplarCharacterSet: NSString; cvar; external;
  NSLocaleCalendar: NSString; cvar; external;
  NSLocaleCollationIdentifier: NSString; cvar; external;
  NSLocaleUsesMetricSystem: NSString; cvar; external;
  NSLocaleMeasurementSystem: NSString; cvar; external;
  NSLocaleDecimalSeparator: NSString; cvar; external;
  NSLocaleGroupingSeparator: NSString; cvar; external;
  NSLocaleCurrencySymbol: NSString; cvar; external;
  NSLocaleCurrencyCode: NSString; cvar; external;
  NSLocaleCollatorIdentifier: NSString; cvar; external;
  NSLocaleQuotationBeginDelimiterKey: NSString; cvar; external;
  NSLocaleQuotationEndDelimiterKey: NSString; cvar; external;
  NSLocaleAlternateQuotationBeginDelimiterKey: NSString; cvar; external;
  NSLocaleAlternateQuotationEndDelimiterKey: NSString; cvar; external;
  NSGregorianCalendar: NSString; cvar; external;
  NSBuddhistCalendar: NSString; cvar; external;
  NSChineseCalendar: NSString; cvar; external;
  NSHebrewCalendar: NSString; cvar; external;
  NSIslamicCalendar: NSString; cvar; external;
  NSIslamicCivilCalendar: NSString; cvar; external;
  NSJapaneseCalendar: NSString; cvar; external;
  NSRepublicOfChinaCalendar: NSString; cvar; external;
  NSPersianCalendar: NSString; cvar; external;
  NSIndianCalendar: NSString; cvar; external;
  NSISO8601Calendar: NSString; cvar; external;
{$endif}

