{ Parsed from Foundation.framework (iPhoneOS5.0) NSObject.h }
{ Created on Tue Feb 7 7:54:46 2012 }


{ Types from NSObject_NSDeprecatedMethods }
{$ifdef TYPES}

{$endif}

{$ifdef PROTOCOLS}

type
  NSObjectProtocol = objcprotocol external name 'NSObject'
    function isEqual (object_: id): boolean; message 'isEqual:';
    function hash: NSUInteger; message 'hash';
    function superclass: pobjc_class; message 'superclass';
    function class_: pobjc_class; message 'class';
    function self_: id; message 'self';
    function zone: NSZone; message 'zone';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    function isProxy: boolean; message 'isProxy';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    procedure release; message 'release';
    function autorelease: id; message 'autorelease';
    function retainCount: NSUInteger; message 'retainCount';
    function description: NSString; message 'description';
    function debugDescription: NSString; message 'debugDescription';
  end;

type
  NSCopyingProtocol = objcprotocol external name 'NSCopying'
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;

type
  NSMutableCopyingProtocol = objcprotocol external name 'NSMutableCopying'
    function mutableCopyWithZone (zone: NSZone): id; message 'mutableCopyWithZone:';
  end;

type
  NSCodingProtocol = objcprotocol external name 'NSCoding'
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSObject = objcclass external (NSObjectProtocol)
  private
    isa: pobjc_class;
  public
    class procedure load; message 'load';
    class procedure initialize; message 'initialize';
    function init: id; message 'init';
    class function new_: id; message 'new';
    class function allocWithZone (zone: NSZone): id; message 'allocWithZone:';
    class function alloc: id; message 'alloc';
    procedure dealloc; message 'dealloc';
    procedure finalize; message 'finalize';
    function copy: id; message 'copy';
    function mutableCopy: id; message 'mutableCopy';
    class function classCopyWithZone (zone: NSZone): id; message 'copyWithZone:';
    class function classMutableCopyWithZone (zone: NSZone): id; message 'mutableCopyWithZone:';
    class function classSuperclass: pobjc_class; message 'superclass';
    class function classClass: pobjc_class; message 'class';
    class function instancesRespondToSelector (aSelector: SEL): boolean; message 'instancesRespondToSelector:';
    class function classConformsToProtocol (protocol_: Protocol): boolean; message 'conformsToProtocol:';
    function methodForSelector (aSelector: SEL): IMP; message 'methodForSelector:';
    class function instanceMethodForSelector (aSelector: SEL): IMP; message 'instanceMethodForSelector:';
    procedure doesNotRecognizeSelector (aSelector: SEL); message 'doesNotRecognizeSelector:';
    function forwardingTargetForSelector (aSelector: SEL): id; message 'forwardingTargetForSelector:';
    procedure forwardInvocation (anInvocation: NSInvocation); message 'forwardInvocation:';
    function methodSignatureForSelector (aSelector: SEL): NSMethodSignature; message 'methodSignatureForSelector:';
    class function instanceMethodSignatureForSelector (aSelector: SEL): NSMethodSignature; message 'instanceMethodSignatureForSelector:';
    function allowsWeakReferenceretainWeakReferencedescription: boolean; message 'allowsWeakReferenceretainWeakReferencedescription';
    class function isSubclassOfClass (aClass: pobjc_class): boolean; message 'isSubclassOfClass:';
    class function resolveClassMethod (sel_: SEL): boolean; message 'resolveClassMethod:';
    class function resolveInstanceMethod (sel_: SEL): boolean; message 'resolveInstanceMethod:';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
  end;


type
  NSObject_NSCoderMethods = objccategory external name 'NSCoderMethods' (NSObject)
    class function version: NSInteger; message 'version';
    class procedure setVersion (aVersion: NSInteger); message 'setVersion:';
    function classForCoder: pobjc_class; message 'classForCoder';
    function replacementObjectForCoder (aCoder: NSCoder): id; message 'replacementObjectForCoder:';
    function awakeAfterUsingCoder (aDecoder: NSCoder): id; message 'awakeAfterUsingCoder:';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not(defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSObject_NSDeprecatedMethods = objccategory external name 'NSDeprecatedMethods' (NSObject)
  end;
{$endif}

{$endif}
{$ifdef PROTOCOLS}

type
  NSDiscardableContentProtocol = objcprotocol external name 'NSDiscardableContent'
    {$if (MAC_OS_X_VERSION_10_6 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
    function beginContentAccess: boolean; message 'beginContentAccess';
    procedure endContentAccess; message 'endContentAccess';
    procedure discardContentIfPossible; message 'discardContentIfPossible';
    function isContentDiscarded: boolean; message 'isContentDiscarded';
    {$endif}
  end;
{$endif}

{$ifdef CLASSES}

type
  NSObject_NSDiscardableContentProxy = objccategory external name 'NSDiscardableContentProxy' (NSObject)
    function autoContentAccessingProxy: id; message 'autoContentAccessingProxy';
  end;
{$endif}

{$ifdef FUNCTIONS}
function NSAllocateObject(aClass: pobjc_class; extraBytes: NSUInteger; zone: NSZone): id; cdecl; external;
function NSDeallocateObject(object_: id): pointer; cdecl; external;
function NSCopyObject(object_: id; extraBytes: NSUInteger; zone: NSZone): id; cdecl; external;
function NSShouldRetainWithZone(anObject: id; requestedZone: NSZone): boolean; cdecl; external;
function NSIncrementExtraRefCount(object_: id): pointer; cdecl; external;
function NSDecrementExtraRefCountWasZero(object_: id): boolean; cdecl; external;
function NSExtraRefCount(object_: id): NSUInteger; cdecl; external;
{$endif}

