{ Parsed from Foundation.framework (iPhoneOS5.0) NSStream.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSStreamStatusNotOpen = 0;
  NSStreamStatusOpening = 1;
  NSStreamStatusOpen = 2;
  NSStreamStatusReading = 3;
  NSStreamStatusWriting = 4;
  NSStreamStatusAtEnd = 5;
  NSStreamStatusClosed = 6;
  NSStreamStatusError = 7;

type
  NSStreamStatus = NSUInteger;
  NSStreamStatusPtr = ^NSStreamStatus;

const
  NSStreamEventNone = 0;
  NSStreamEventOpenCompleted = 1 shl 0;
  NSStreamEventHasBytesAvailable = 1 shl 1;
  NSStreamEventHasSpaceAvailable = 1 shl 2;
  NSStreamEventErrorOccurred = 1 shl 3;
  NSStreamEventEndEncountered = 1 shl 4;

type
  NSStreamEvent = NSUInteger;
  NSStreamEventPtr = ^NSStreamEvent;
{$endif}

{$ifdef CLASSES}

type
  NSStream = objcclass external (NSObject)
  public
    procedure open; message 'open';
    procedure close; message 'close';
    function delegate: NSStreamDelegateProtocol; message 'delegate';
    procedure setDelegate (delegate_: NSStreamDelegateProtocol); message 'setDelegate:';
    function propertyForKey (key: NSString): id; message 'propertyForKey:';
    function setProperty_forKey (property_: id; key: NSString): boolean; message 'setProperty:forKey:';
    procedure scheduleInRunLoop_forMode (aRunLoop: NSRunLoop; mode: NSString); message 'scheduleInRunLoop:forMode:';
    procedure removeFromRunLoop_forMode (aRunLoop: NSRunLoop; mode: NSString); message 'removeFromRunLoop:forMode:';
    function streamStatus: NSStreamStatus; message 'streamStatus';
    function streamError: NSError; message 'streamError';
  end;

type
  NSInputStream = objcclass external (NSStream)
  public
    function read_maxLength (buffer: pbyte; len: NSUInteger): NSInteger; message 'read:maxLength:';
    function getBuffer_length (buffer: pbyte; len: NSUInteger): boolean; message 'getBuffer:length:';
    function hasBytesAvailable: boolean; message 'hasBytesAvailable';
  end;

type
  NSOutputStream = objcclass external (NSStream)
  public
    function write_maxLength (buffer: pbyte; len: NSUInteger): NSInteger; message 'write:maxLength:';
    function hasSpaceAvailable: boolean; message 'hasSpaceAvailable';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not(defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSStream_NSSocketStreamCreationExtensions = objccategory external name 'NSSocketStreamCreationExtensions' (NSStream)
    class procedure getStreamsToHost_port_inputStream_outputStream (host: NSHost; port: NSInteger; inputStream: NSInputStreamPtr; outputStream: NSOutputStreamPtr); message 'getStreamsToHost:port:inputStream:outputStream:';
  end;
{$endif}

{$endif}
{$ifdef CLASSES}

type
  NSInputStream_NSInputStreamExtensions = objccategory external name 'NSInputStreamExtensions' (NSInputStream)
    function initWithData (data: NSData): id; message 'initWithData:';
    function initWithFileAtPath (path: NSString): id; message 'initWithFileAtPath:';
    function initWithURL (url: NSURL): id; message 'initWithURL:';
    class function inputStreamWithData (data: NSData): id; message 'inputStreamWithData:';
    class function inputStreamWithFileAtPath (path: NSString): id; message 'inputStreamWithFileAtPath:';
    class function inputStreamWithURL (url: NSURL): id; message 'inputStreamWithURL:';
  end;

type
  NSOutputStream_NSOutputStreamExtensions = objccategory external name 'NSOutputStreamExtensions' (NSOutputStream)
    function initToMemory: id; message 'initToMemory';
    function initToBuffer_capacity (buffer: pbyte; capacity: NSUInteger): id; message 'initToBuffer:capacity:';
    function initToFileAtPath_append (path: NSString; shouldAppend: boolean): id; message 'initToFileAtPath:append:';
    function initWithURL_append (url: NSURL; shouldAppend: boolean): id; message 'initWithURL:append:';
    class function outputStreamToMemory: id; message 'outputStreamToMemory';
    class function outputStreamToBuffer_capacity (buffer: pbyte; capacity: NSUInteger): id; message 'outputStreamToBuffer:capacity:';
    class function outputStreamToFileAtPath_append (path: NSString; shouldAppend: boolean): id; message 'outputStreamToFileAtPath:append:';
    class function outputStreamWithURL_append (url: NSURL; shouldAppend: boolean): id; message 'outputStreamWithURL:append:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSStreamDelegateProtocol = objcprotocol external name 'NSStreamDelegate'
  optional
    procedure stream_handleEvent (aStream: NSStream; eventCode: NSStreamEvent); message 'stream:handleEvent:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSStreamSocketSecurityLevelKey: NSString; cvar; external;
  NSStreamSocketSecurityLevelNone: NSString; cvar; external;
  NSStreamSocketSecurityLevelSSLv2: NSString; cvar; external;
  NSStreamSocketSecurityLevelSSLv3: NSString; cvar; external;
  NSStreamSocketSecurityLevelTLSv1: NSString; cvar; external;
  NSStreamSocketSecurityLevelNegotiatedSSL: NSString; cvar; external;
  NSStreamSOCKSProxyConfigurationKey: NSString; cvar; external;
  NSStreamSOCKSProxyHostKey: NSString; cvar; external;
  NSStreamSOCKSProxyPortKey: NSString; cvar; external;
  NSStreamSOCKSProxyVersionKey: NSString; cvar; external;
  NSStreamSOCKSProxyUserKey: NSString; cvar; external;
  NSStreamSOCKSProxyPasswordKey: NSString; cvar; external;
  NSStreamSOCKSProxyVersion4: NSString; cvar; external;
  NSStreamSOCKSProxyVersion5: NSString; cvar; external;
  NSStreamDataWrittenToMemoryStreamKey: NSString; cvar; external;
  NSStreamFileCurrentOffsetKey: NSString; cvar; external;
  NSStreamSocketSSLErrorDomain: NSString; cvar; external;
  NSStreamSOCKSErrorDomain: NSString; cvar; external;
  NSStreamNetworkServiceType: NSString; cvar; external;
  NSStreamNetworkServiceTypeVoIP: NSString; cvar; external;
  NSStreamNetworkServiceTypeVideo: NSString; cvar; external;
  NSStreamNetworkServiceTypeBackground: NSString; cvar; external;
  NSStreamNetworkServiceTypeVoice: NSString; cvar; external;
{$endif}

