{ Parsed from Foundation.framework (iPhoneOS5.0) NSTextCheckingResult.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSTextCheckingTypeOrthography = 1 shl 0;
  NSTextCheckingTypeSpelling = 1 shl 1;
  NSTextCheckingTypeGrammar = 1 shl 2;
  NSTextCheckingTypeDate = 1 shl 3;
  NSTextCheckingTypeAddress = 1 shl 4;
  NSTextCheckingTypeLink = 1 shl 5;
  NSTextCheckingTypeQuote = 1 shl 6;
  NSTextCheckingTypeDash = 1 shl 7;
  NSTextCheckingTypeReplacement = 1 shl 8;
  NSTextCheckingTypeCorrection = 1 shl 9;
  {$if (MAC_OS_X_VERSION_10_7 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  NSTextCheckingTypeRegularExpression = 1 shl 10;
  NSTextCheckingTypePhoneNumber = 1 shl 11;
  NSTextCheckingTypeTransitInformation = 1 shl 12;
  {$endif}

type
  NSTextCheckingType = cuint64;
  NSTextCheckingTypePtr = ^NSTextCheckingType;

const
  NSTextCheckingAllSystemTypes = $ffffffff;
  NSTextCheckingAllCustomTypes = $ffffffff shl 32;
  NSTextCheckingAllTypes = NSTextCheckingAllSystemTypes + NSTextCheckingAllCustomTypes;

type
  NSTextCheckingTypes = cuint64;
  NSTextCheckingTypesPtr = ^NSTextCheckingTypes;
{$endif}

{$ifdef CLASSES}

type
  NSTextCheckingResult = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  public
    function resultType: NSTextCheckingType; message 'resultType';
    function range: NSRange; message 'range';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSTextCheckingResult_NSTextCheckingResultOptional = objccategory external name 'NSTextCheckingResultOptional' (NSTextCheckingResult)
    function orthography: NSOrthography; message 'orthography';
    function grammarDetails: NSArray; message 'grammarDetails';
    function date: NSDate; message 'date';
    function timeZone: NSTimeZone; message 'timeZone';
    function duration: NSTimeInterval; message 'duration';
    function components: NSDictionary; message 'components';
    function URL: NSURL; message 'URL';
    function replacementString: NSString; message 'replacementString';
    function regularExpression: NSRegularExpression; message 'regularExpression';
    function phoneNumber: NSString; message 'phoneNumber';
    function addressComponents: NSDictionary; message 'addressComponents';
    function numberOfRanges: NSUInteger; message 'numberOfRanges';
    function rangeAtIndex (idx: NSUInteger): NSRange; message 'rangeAtIndex:';
    function resultByAdjustingRangesWithOffset (offset: NSInteger): NSTextCheckingResult; message 'resultByAdjustingRangesWithOffset:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSTextCheckingNameKey: NSString; cvar; external;
  NSTextCheckingJobTitleKey: NSString; cvar; external;
  NSTextCheckingOrganizationKey: NSString; cvar; external;
  NSTextCheckingStreetKey: NSString; cvar; external;
  NSTextCheckingCityKey: NSString; cvar; external;
  NSTextCheckingStateKey: NSString; cvar; external;
  NSTextCheckingZIPKey: NSString; cvar; external;
  NSTextCheckingCountryKey: NSString; cvar; external;
  NSTextCheckingPhoneKey: NSString; cvar; external;
  NSTextCheckingAirlineKey: NSString; cvar; external;
  NSTextCheckingFlightKey: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSTextCheckingResult_NSTextCheckingResultCreation = objccategory external name 'NSTextCheckingResultCreation' (NSTextCheckingResult)
    class function orthographyCheckingResultWithRange_orthography (range_: NSRange; orthography: NSOrthography): NSTextCheckingResult; message 'orthographyCheckingResultWithRange:orthography:';
    class function spellCheckingResultWithRange (range_: NSRange): NSTextCheckingResult; message 'spellCheckingResultWithRange:';
    class function grammarCheckingResultWithRange_details (range_: NSRange; details: NSArray): NSTextCheckingResult; message 'grammarCheckingResultWithRange:details:';
    class function dateCheckingResultWithRange_date (range_: NSRange; date: NSDate): NSTextCheckingResult; message 'dateCheckingResultWithRange:date:';
    class function dateCheckingResultWithRange_date_timeZone_duration (range_: NSRange; date: NSDate; timeZone: NSTimeZone; duration: NSTimeInterval): NSTextCheckingResult; message 'dateCheckingResultWithRange:date:timeZone:duration:';
    class function addressCheckingResultWithRange_components (range_: NSRange; components: NSDictionary): NSTextCheckingResult; message 'addressCheckingResultWithRange:components:';
    class function linkCheckingResultWithRange_URL (range_: NSRange; url: NSURL): NSTextCheckingResult; message 'linkCheckingResultWithRange:URL:';
    class function quoteCheckingResultWithRange_replacementString (range_: NSRange; replacementString: NSString): NSTextCheckingResult; message 'quoteCheckingResultWithRange:replacementString:';
    class function dashCheckingResultWithRange_replacementString (range_: NSRange; replacementString: NSString): NSTextCheckingResult; message 'dashCheckingResultWithRange:replacementString:';
    class function replacementCheckingResultWithRange_replacementString (range_: NSRange; replacementString: NSString): NSTextCheckingResult; message 'replacementCheckingResultWithRange:replacementString:';
    class function correctionCheckingResultWithRange_replacementString (range_: NSRange; replacementString: NSString): NSTextCheckingResult; message 'correctionCheckingResultWithRange:replacementString:';
    class function regularExpressionCheckingResultWithRanges_count_regularExpression (ranges: NSRangePointer; count: NSUInteger; regularExpression: NSRegularExpression): NSTextCheckingResult; message 'regularExpressionCheckingResultWithRanges:count:regularExpression:';
    class function phoneNumberCheckingResultWithRange_phoneNumber (range_: NSRange; phoneNumber: NSString): NSTextCheckingResult; message 'phoneNumberCheckingResultWithRange:phoneNumber:';
    class function transitInformationCheckingResultWithRange_components (range_: NSRange; components: NSDictionary): NSTextCheckingResult; message 'transitInformationCheckingResultWithRange:components:';
  end;
{$endif}

