{ Parsed from Foundation.framework (iPhoneOS5.0) NSTimeZone.h }
{ Created on Tue Feb 7 7:54:46 2012 }


{ Types from NSTimeZone_NSExtendedTimeZone }
{$ifdef TYPES}

const
  NSTimeZoneNameStyleStandard = 0;
  NSTimeZoneNameStyleShortStandard = 1;
  NSTimeZoneNameStyleDaylightSaving = 2;
  NSTimeZoneNameStyleShortDaylightSaving = 3;
  NSTimeZoneNameStyleGeneric = 4;
  NSTimeZoneNameStyleShortGeneric = 5;

type
  NSTimeZoneNameStyle = NSInteger;
type
  NSTimeZoneNameStylePtr = ^NSTimeZoneNameStyle;
{$endif}

{$ifdef CLASSES}

type
  NSTimeZone = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  public
    function name: NSString; message 'name';
    function data: NSData; message 'data';
    function secondsFromGMTForDate (aDate: NSDate): NSInteger; message 'secondsFromGMTForDate:';
    function abbreviationForDate (aDate: NSDate): NSString; message 'abbreviationForDate:';
    function isDaylightSavingTimeForDate (aDate: NSDate): boolean; message 'isDaylightSavingTimeForDate:';
    function daylightSavingTimeOffsetForDate (aDate: NSDate): NSTimeInterval; message 'daylightSavingTimeOffsetForDate:';
    function nextDaylightSavingTimeTransitionAfterDate (aDate: NSDate): NSDate; message 'nextDaylightSavingTimeTransitionAfterDate:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSTimeZone_NSExtendedTimeZone = objccategory external name 'NSExtendedTimeZone' (NSTimeZone)
    class function systemTimeZone: NSTimeZone; message 'systemTimeZone';
    class procedure resetSystemTimeZone; message 'resetSystemTimeZone';
    class function defaultTimeZone: NSTimeZone; message 'defaultTimeZone';
    class procedure setDefaultTimeZone (aTimeZone: NSTimeZone); message 'setDefaultTimeZone:';
    class function localTimeZone: NSTimeZone; message 'localTimeZone';
    class function knownTimeZoneNames: NSArray; message 'knownTimeZoneNames';
    class function abbreviationDictionary: NSDictionary; message 'abbreviationDictionary';
    class procedure setAbbreviationDictionary (dict: NSDictionary); message 'setAbbreviationDictionary:';
    class function timeZoneDataVersion: NSString; message 'timeZoneDataVersion';
    function secondsFromGMT: NSInteger; message 'secondsFromGMT';
    function abbreviation: NSString; message 'abbreviation';
    function isDaylightSavingTime: boolean; message 'isDaylightSavingTime';
    function daylightSavingTimeOffset: NSTimeInterval; message 'daylightSavingTimeOffset';
    function nextDaylightSavingTimeTransition: NSDate; message 'nextDaylightSavingTimeTransition';
    function description: NSString; message 'description';
    function isEqualToTimeZone (aTimeZone: NSTimeZone): boolean; message 'isEqualToTimeZone:';
    function localizedName_locale (style: NSTimeZoneNameStyle; locale: NSLocale): NSString; message 'localizedName:locale:';
  end;

type
  NSTimeZone_NSTimeZoneCreation = objccategory external name 'NSTimeZoneCreation' (NSTimeZone)
    class function timeZoneWithName (tzName: NSString): id; message 'timeZoneWithName:';
    class function timeZoneWithName_data (tzName: NSString; aData: NSData): id; message 'timeZoneWithName:data:';
    function initWithName (tzName: NSString): id; message 'initWithName:';
    function initWithName_data (tzName: NSString; aData: NSData): id; message 'initWithName:data:';
    class function timeZoneForSecondsFromGMT (seconds: NSInteger): id; message 'timeZoneForSecondsFromGMT:';
    class function timeZoneWithAbbreviation (abbreviation: NSString): id; message 'timeZoneWithAbbreviation:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSSystemTimeZoneDidChangeNotification: NSString; cvar; external;
{$endif}

