{ Parsed from Foundation.framework (iPhoneOS5.0) NSURL.h }
{ Created on Tue Feb 7 7:54:46 2012 }


{ Types from NSURL }
{$ifdef TYPES}

{$endif}

{$if (MAC_OS_X_VERSION_10_6 <= MAC_OS_X_VERSION_MAX_ALLOWED) or (__IPHONE_4_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
{$ifdef TYPES}
const
  NSURLBookmarkCreationPreferFileIDResolution = 1 shl 8;
  NSURLBookmarkCreationMinimalBookmark = 1 shl 9;
  NSURLBookmarkCreationSuitableForBookmarkFile = 1 shl 10;
const
  NSURLBookmarkResolutionWithoutUI = 1 shl 8;
  NSURLBookmarkResolutionWithoutMounting = 1 shl 9;
{$endif}

{$endif}
{$ifdef TYPES}
type
  NSURLBookmarkCreationOptions = NSUInteger;
  NSURLBookmarkCreationOptionsPtr = ^NSURLBookmarkCreationOptions;
  NSURLBookmarkResolutionOptions = NSUInteger;
  NSURLBookmarkResolutionOptionsPtr = ^NSURLBookmarkResolutionOptions;
  NSURLBookmarkFileCreationOptions = NSUInteger;
  NSURLBookmarkFileCreationOptionsPtr = ^NSURLBookmarkFileCreationOptions;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSURLFileScheme: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSURL = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol)
  private
    _urlString: NSString;
    _baseURL: NSURL;
    _clients: pointer;
    _reserved: pointer;
  public
    function initWithScheme_host_path (scheme: NSString; host: NSString; path: NSString): id; message 'initWithScheme:host:path:';
    function initFileURLWithPath_isDirectory (path: NSString; isDir: boolean): id; message 'initFileURLWithPath:isDirectory:';
    function initFileURLWithPath (path: NSString): id; message 'initFileURLWithPath:';
    class function fileURLWithPath_isDirectory (path: NSString; isDir: boolean): id; message 'fileURLWithPath:isDirectory:';
    class function fileURLWithPath (path: NSString): id; message 'fileURLWithPath:';
    class function URLWithString (URLString: NSString): id; message 'URLWithString:';
    class function URLWithString_relativeToURL (URLString: NSString; baseURL: NSURL): id; message 'URLWithString:relativeToURL:';
    function absoluteString: NSString; message 'absoluteString';
    function relativeString: NSString; message 'relativeString';
    function baseURL: NSURL; message 'baseURL';
    function absoluteURL: NSURL; message 'absoluteURL';
    function scheme: NSString; message 'scheme';
    function resourceSpecifier: NSString; message 'resourceSpecifier';
    function host: NSString; message 'host';
    function port: NSNumber; message 'port';
    function user: NSString; message 'user';
    function password: NSString; message 'password';
    function path: NSString; message 'path';
    function fragment: NSString; message 'fragment';
    function parameterString: NSString; message 'parameterString';
    function query: NSString; message 'query';
    function relativePath: NSString; message 'relativePath';
    function isFileURL: boolean; message 'isFileURL';
    function standardizedURL: NSURL; message 'standardizedURL';
    function getResourceValue_forKey_error (value: idPtr; key: NSString; error: NSErrorPtr): boolean; message 'getResourceValue:forKey:error:';
    function resourceValuesForKeys_error (keys: NSArray; error: NSErrorPtr): NSDictionary; message 'resourceValuesForKeys:error:';
    function setResourceValue_forKey_error (value: id; key: NSString; error: NSErrorPtr): boolean; message 'setResourceValue:forKey:error:';
    function setResourceValues_error (keyedValues: NSDictionary; error: NSErrorPtr): boolean; message 'setResourceValues:error:';
    function checkResourceIsReachableAndReturnError (error: NSErrorPtr): boolean; message 'checkResourceIsReachableAndReturnError:';
    function isFileReferenceURL: boolean; message 'isFileReferenceURL';
    function fileReferenceURL: NSURL; message 'fileReferenceURL';
    function filePathURL: NSURL; message 'filePathURL';
    function bookmarkDataWithOptions_includingResourceValuesForKeys_relativeToURL_error (options: NSURLBookmarkCreationOptions; keys: NSArray; relativeURL: NSURL; error: NSErrorPtr): NSData; message 'bookmarkDataWithOptions:includingResourceValuesForKeys:relativeToURL:error:';
    function initByResolvingBookmarkData_options_relativeToURL_bookmarkDataIsStale_error (bookmarkData: NSData; options: NSURLBookmarkResolutionOptions; relativeURL: NSURL; isStale: pboolean; error: NSErrorPtr): id; message 'initByResolvingBookmarkData:options:relativeToURL:bookmarkDataIsStale:error:';
    class function URLByResolvingBookmarkData_options_relativeToURL_bookmarkDataIsStale_error (bookmarkData: NSData; options: NSURLBookmarkResolutionOptions; relativeURL: NSURL; isStale: pboolean; error: NSErrorPtr): id; message 'URLByResolvingBookmarkData:options:relativeToURL:bookmarkDataIsStale:error:';
    class function resourceValuesForKeys_fromBookmarkData (keys: NSArray; bookmarkData: NSData): NSDictionary; message 'resourceValuesForKeys:fromBookmarkData:';
    class function writeBookmarkData_toURL_options_error (bookmarkData: NSData; bookmarkFileURL: NSURL; options: NSURLBookmarkFileCreationOptions; error: NSErrorPtr): boolean; message 'writeBookmarkData:toURL:options:error:';
    class function bookmarkDataWithContentsOfURL_error (bookmarkFileURL: NSURL; error: NSErrorPtr): NSData; message 'bookmarkDataWithContentsOfURL:error:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSString_NSURLUtilities = objccategory external name 'NSURLUtilities' (NSString)
    function stringByAddingPercentEscapesUsingEncoding (enc: NSStringEncoding): NSString; message 'stringByAddingPercentEscapesUsingEncoding:';
    function stringByReplacingPercentEscapesUsingEncoding (enc: NSStringEncoding): NSString; message 'stringByReplacingPercentEscapesUsingEncoding:';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not(defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSObject_NSURLClient = objccategory external name 'NSURLClient' (NSObject)
    procedure URL_resourceDataDidBecomeAvailable (sender: NSURL; newBytes: NSData); message 'URL:resourceDataDidBecomeAvailable:';
    procedure URLResourceDidFinishLoading (sender: NSURL); message 'URLResourceDidFinishLoading:';
    procedure URLResourceDidCancelLoading (sender: NSURL); message 'URLResourceDidCancelLoading:';
    procedure URL_resourceDidFailLoadingWithReason (sender: NSURL; reason: NSString); message 'URL:resourceDidFailLoadingWithReason:';
  end;

type
  NSURL_NSURLLoading = objccategory external name 'NSURLLoading' (NSURL)
    function resourceDataUsingCache (shouldUseCache: boolean): NSData; message 'resourceDataUsingCache:';
    procedure loadResourceDataNotifyingClient_usingCache (client: id; shouldUseCache: boolean); message 'loadResourceDataNotifyingClient:usingCache:';
    function propertyForKey (propertyKey: NSString): id; message 'propertyForKey:';
    function setResourceData (data: NSData): boolean; message 'setResourceData:';
    function setProperty_forKey (property_: id; propertyKey: NSString): boolean; message 'setProperty:forKey:';
    function URLHandleUsingCache (shouldUseCache: boolean): NSURLHandlePtr; message 'URLHandleUsingCache:';
  end;
{$endif}

{$endif}
{$ifdef CLASSES}

type
  NSURL_NSURLPathUtilities = objccategory external name 'NSURLPathUtilities' (NSURL)
    class function fileURLWithPathComponents (components: NSArray): NSURL; message 'fileURLWithPathComponents:';
    function pathComponents: NSArray; message 'pathComponents';
    function lastPathComponent: NSString; message 'lastPathComponent';
    function pathExtension: NSString; message 'pathExtension';
    function URLByAppendingPathComponent (pathComponent: NSString): NSURL; message 'URLByAppendingPathComponent:';
    function URLByAppendingPathComponent_isDirectory (pathComponent: NSString; isDirectory: boolean): NSURL; message 'URLByAppendingPathComponent:isDirectory:';
    function URLByDeletingLastPathComponent: NSURL; message 'URLByDeletingLastPathComponent';
    function URLByAppendingPathExtension (pathExtension_: NSString): NSURL; message 'URLByAppendingPathExtension:';
    function URLByDeletingPathExtension: NSURL; message 'URLByDeletingPathExtension';
    function URLByStandardizingPath: NSURL; message 'URLByStandardizingPath';
    function URLByResolvingSymlinksInPath: NSURL; message 'URLByResolvingSymlinksInPath';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) or (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSFileSecurity = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;
{$endif}

{$endif}
{$ifdef EXTERNAL_SYMBOLS}
var
  NSURLNameKey: NSString; cvar; external;
  NSURLLocalizedNameKey: NSString; cvar; external;
  NSURLIsRegularFileKey: NSString; cvar; external;
  NSURLIsDirectoryKey: NSString; cvar; external;
  NSURLIsSymbolicLinkKey: NSString; cvar; external;
  NSURLIsVolumeKey: NSString; cvar; external;
  NSURLIsPackageKey: NSString; cvar; external;
  NSURLIsSystemImmutableKey: NSString; cvar; external;
  NSURLIsUserImmutableKey: NSString; cvar; external;
  NSURLIsHiddenKey: NSString; cvar; external;
  NSURLHasHiddenExtensionKey: NSString; cvar; external;
  NSURLCreationDateKey: NSString; cvar; external;
  NSURLContentAccessDateKey: NSString; cvar; external;
  NSURLContentModificationDateKey: NSString; cvar; external;
  NSURLAttributeModificationDateKey: NSString; cvar; external;
  NSURLLinkCountKey: NSString; cvar; external;
  NSURLParentDirectoryURLKey: NSString; cvar; external;
  NSURLVolumeURLKey: NSString; cvar; external;
  NSURLTypeIdentifierKey: NSString; cvar; external;
  NSURLLocalizedTypeDescriptionKey: NSString; cvar; external;
  NSURLLabelNumberKey: NSString; cvar; external;
  NSURLLabelColorKey: NSString; cvar; external;
  NSURLLocalizedLabelKey: NSString; cvar; external;
  NSURLEffectiveIconKey: NSString; cvar; external;
  NSURLCustomIconKey: NSString; cvar; external;
  NSURLFileResourceIdentifierKey: NSString; cvar; external;
  NSURLVolumeIdentifierKey: NSString; cvar; external;
  NSURLPreferredIOBlockSizeKey: NSString; cvar; external;
  NSURLIsReadableKey: NSString; cvar; external;
  NSURLIsWritableKey: NSString; cvar; external;
  NSURLIsExecutableKey: NSString; cvar; external;
  NSURLIsMountTriggerKey: NSString; cvar; external;
  NSURLFileSecurityKey: NSString; cvar; external;
  NSURLFileResourceTypeKey: NSString; cvar; external;
  NSURLFileResourceTypeNamedPipe: NSString; cvar; external;
  NSURLFileResourceTypeCharacterSpecial: NSString; cvar; external;
  NSURLFileResourceTypeDirectory: NSString; cvar; external;
  NSURLFileResourceTypeBlockSpecial: NSString; cvar; external;
  NSURLFileResourceTypeRegular: NSString; cvar; external;
  NSURLFileResourceTypeSymbolicLink: NSString; cvar; external;
  NSURLFileResourceTypeSocket: NSString; cvar; external;
  NSURLFileResourceTypeUnknown: NSString; cvar; external;
  NSURLFileSizeKey: NSString; cvar; external;
  NSURLFileAllocatedSizeKey: NSString; cvar; external;
  NSURLTotalFileSizeKey: NSString; cvar; external;
  NSURLTotalFileAllocatedSizeKey: NSString; cvar; external;
  NSURLIsAliasFileKey: NSString; cvar; external;
  NSURLVolumeLocalizedFormatDescriptionKey: NSString; cvar; external;
  NSURLVolumeTotalCapacityKey: NSString; cvar; external;
  NSURLVolumeAvailableCapacityKey: NSString; cvar; external;
  NSURLVolumeResourceCountKey: NSString; cvar; external;
  NSURLVolumeSupportsPersistentIDsKey: NSString; cvar; external;
  NSURLVolumeSupportsSymbolicLinksKey: NSString; cvar; external;
  NSURLVolumeSupportsHardLinksKey: NSString; cvar; external;
  NSURLVolumeSupportsJournalingKey: NSString; cvar; external;
  NSURLVolumeIsJournalingKey: NSString; cvar; external;
  NSURLVolumeSupportsSparseFilesKey: NSString; cvar; external;
  NSURLVolumeSupportsZeroRunsKey: NSString; cvar; external;
  NSURLVolumeSupportsCaseSensitiveNamesKey: NSString; cvar; external;
  NSURLVolumeSupportsCasePreservedNamesKey: NSString; cvar; external;
  NSURLVolumeSupportsRootDirectoryDatesKey: NSString; cvar; external;
  NSURLVolumeSupportsVolumeSizesKey: NSString; cvar; external;
  NSURLVolumeSupportsRenamingKey: NSString; cvar; external;
  NSURLVolumeSupportsAdvisoryFileLockingKey: NSString; cvar; external;
  NSURLVolumeSupportsExtendedSecurityKey: NSString; cvar; external;
  NSURLVolumeIsBrowsableKey: NSString; cvar; external;
  NSURLVolumeMaximumFileSizeKey: NSString; cvar; external;
  NSURLVolumeIsEjectableKey: NSString; cvar; external;
  NSURLVolumeIsRemovableKey: NSString; cvar; external;
  NSURLVolumeIsInternalKey: NSString; cvar; external;
  NSURLVolumeIsAutomountedKey: NSString; cvar; external;
  NSURLVolumeIsLocalKey: NSString; cvar; external;
  NSURLVolumeIsReadOnlyKey: NSString; cvar; external;
  NSURLVolumeCreationDateKey: NSString; cvar; external;
  NSURLVolumeURLForRemountingKey: NSString; cvar; external;
  NSURLVolumeUUIDStringKey: NSString; cvar; external;
  NSURLVolumeNameKey: NSString; cvar; external;
  NSURLVolumeLocalizedNameKey: NSString; cvar; external;
  NSURLIsUbiquitousItemKey: NSString; cvar; external;
  NSURLUbiquitousItemHasUnresolvedConflictsKey: NSString; cvar; external;
  NSURLUbiquitousItemIsDownloadedKey: NSString; cvar; external;
  NSURLUbiquitousItemIsDownloadingKey: NSString; cvar; external;
  NSURLUbiquitousItemIsUploadedKey: NSString; cvar; external;
  NSURLUbiquitousItemIsUploadingKey: NSString; cvar; external;
  NSURLUbiquitousItemPercentDownloadedKey: NSString; cvar; external;
  NSURLUbiquitousItemPercentUploadedKey: NSString; cvar; external;
{$endif}

