{ Parsed from Foundation.framework (iPhoneOS5.0) NSURLCredential.h }
{ Created on Tue Feb 7 7:54:46 2012 }

{$ifdef TYPES}
const
  NSURLCredentialPersistenceNone = 0;
  NSURLCredentialPersistenceForSession = 1;
  NSURLCredentialPersistencePermanent = 2;

type
  NSURLCredentialPersistence = NSUInteger;
  NSURLCredentialPersistencePtr = ^NSURLCredentialPersistence;
{$endif}

{$ifdef CLASSES}

type
  NSURLCredential = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol)
  private
    _internal: NSURLCredentialInternal;
  public
    function persistence: NSURLCredentialPersistence; message 'persistence';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function copyWithZone (zone: NSZone): id; message 'copyWithZone:';
  end;


type
  NSURLCredential_NSInternetPassword = objccategory external name 'NSInternetPassword' (NSURLCredential)
    function initWithUser_password_persistence (user: NSString; password: NSString; persistence_: NSURLCredentialPersistence): id; message 'initWithUser:password:persistence:';
    class function credentialWithUser_password_persistence (user: NSString; password: NSString; persistence_: NSURLCredentialPersistence): NSURLCredential; message 'credentialWithUser:password:persistence:';
    function user: NSString; message 'user';
    function password: NSString; message 'password';
    function hasPassword: boolean; message 'hasPassword';
  end;

type
  NSURLCredential_NSClientCertificate = objccategory external name 'NSClientCertificate' (NSURLCredential)
    function initWithIdentity_certificates_persistence (identity: SecIdentityRef; certArray: NSArray; persistence_: NSURLCredentialPersistence): id; message 'initWithIdentity:certificates:persistence:';
    class function credentialWithIdentity_certificates_persistence (identity: SecIdentityRef; certArray: NSArray; persistence_: NSURLCredentialPersistence): NSURLCredential; message 'credentialWithIdentity:certificates:persistence:';
    function identity: SecIdentityRef; message 'identity';
    function certificates: NSArray; message 'certificates';
  end;

type
  NSURLCredential_NSServerTrust = objccategory external name 'NSServerTrust' (NSURLCredential)
    function initWithTrust (trust: SecTrustRef): id; message 'initWithTrust:';
    class function credentialForTrust (trust: SecTrustRef): NSURLCredential; message 'credentialForTrust:';
  end;
{$endif}

