{ Parsed from UIKit.framework (iPhoneOS5.0) UIAccessibility.h }
{ Created on Tue Feb 7 7:54:47 2012 }


{ Types from NSObject_UIAccessibilityAction }
{$ifdef TYPES}

const
  UIAccessibilityScrollDirectionRight = 1;
  UIAccessibilityScrollDirectionLeft = 2;
  UIAccessibilityScrollDirectionUp = 3;
  UIAccessibilityScrollDirectionDown = 4;
  {$if (__IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_5_0)}
  UIAccessibilityScrollDirectionNext = 5;
  UIAccessibilityScrollDirectionPrevious = 6;
  {$endif}
type
  UIAccessibilityScrollDirection = clong;
{$endif}

{$ifdef CLASSES}

type
  NSObject_UIAccessibility = objccategory external name 'UIAccessibility' (NSObject)
    procedure setIsAccessibilityElement(newValue: boolean); message 'setIsAccessibilityElement:';
    function isAccessibilityElement: boolean; message 'isAccessibilityElement';
    procedure setAccessibilityLabel(newValue: NSString); message 'setAccessibilityLabel:';
    function accessibilityLabel: NSString; message 'accessibilityLabel';
    procedure setAccessibilityHint(newValue: NSString); message 'setAccessibilityHint:';
    function accessibilityHint: NSString; message 'accessibilityHint';
    procedure setAccessibilityValue(newValue: NSString); message 'setAccessibilityValue:';
    function accessibilityValue: NSString; message 'accessibilityValue';
    procedure setAccessibilityTraits(newValue: UIAccessibilityTraits); message 'setAccessibilityTraits:';
    function accessibilityTraits: UIAccessibilityTraits; message 'accessibilityTraits';
    procedure setAccessibilityFrame(newValue: CGRect); message 'setAccessibilityFrame:';
    function accessibilityFrame: CGRect; message 'accessibilityFrame';
    procedure setAccessibilityActivationPoint(newValue: CGPoint); message 'setAccessibilityActivationPoint:';
    function accessibilityActivationPoint: CGPoint; message 'accessibilityActivationPoint';
    procedure setAccessibilityLanguage(newValue: NSString); message 'setAccessibilityLanguage:';
    function accessibilityLanguage: NSString; message 'accessibilityLanguage';
    procedure setAccessibilityElementsHidden(newValue: boolean); message 'setAccessibilityElementsHidden:';
    function accessibilityElementsHidden: boolean; message 'accessibilityElementsHidden';
    procedure setAccessibilityViewIsModal(newValue: boolean); message 'setAccessibilityViewIsModal:';
    function accessibilityViewIsModal: boolean; message 'accessibilityViewIsModal';
  end;

type
  NSObject_UIAccessibilityContainer = objccategory external name 'UIAccessibilityContainer' (NSObject)
    function accessibilityElementCount: NSInteger; message 'accessibilityElementCount';
    function accessibilityElementAtIndex (index: NSInteger): id; message 'accessibilityElementAtIndex:';
    function indexOfAccessibilityElement (element: id): NSInteger; message 'indexOfAccessibilityElement:';
  end;

type
  NSObject_UIAccessibilityFocus = objccategory external name 'UIAccessibilityFocus' (NSObject)
    procedure accessibilityElementDidBecomeFocused; message 'accessibilityElementDidBecomeFocused'; { available starting in __MAC_NA, __IPHONE_4_0 }
    procedure accessibilityElementDidLoseFocus; message 'accessibilityElementDidLoseFocus'; { available starting in __MAC_NA, __IPHONE_4_0 }
    function accessibilityElementIsFocused: boolean; message 'accessibilityElementIsFocused'; { available starting in __MAC_NA, __IPHONE_4_0 }
  end;

type
  NSObject_UIAccessibilityAction = objccategory external name 'UIAccessibilityAction' (NSObject)
    procedure accessibilityIncrement; message 'accessibilityIncrement'; { available starting in __MAC_NA, __IPHONE_4_0 }
    procedure accessibilityDecrement; message 'accessibilityDecrement'; { available starting in __MAC_NA, __IPHONE_4_0 }
    function accessibilityScroll (direction: UIAccessibilityScrollDirection): boolean; message 'accessibilityScroll:'; { available starting in __MAC_NA, __IPHONE_4_2 }
    function accessibilityPerformEscape: boolean; message 'accessibilityPerformEscape'; { available starting in __MAC_NA, __IPHONE_5_0 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIAccessibilityReadingContentProtocol = objcprotocol external name 'UIAccessibilityReadingContent'
  required
    function accessibilityLineNumberForPoint (point: CGPoint): NSInteger; message 'accessibilityLineNumberForPoint:'; { available starting in __MAC_NA, __IPHONE_5_0 }
    function accessibilityContentForLineNumber (lineNumber: NSInteger): NSString; message 'accessibilityContentForLineNumber:'; { available starting in __MAC_NA, __IPHONE_5_0 }
    function accessibilityFrameForLineNumber (lineNumber: NSInteger): CGRect; message 'accessibilityFrameForLineNumber:'; { available starting in __MAC_NA, __IPHONE_5_0 }
    function accessibilityPageContent: NSString; message 'accessibilityPageContent'; { available starting in __MAC_NA, __IPHONE_5_0 }
  end;
{$endif}

{$ifdef FUNCTIONS}
function UIAccessibilityPostNotification(notification: UIAccessibilityNotifications; argument: id): pointer; cdecl; external;
function UIAccessibilityIsVoiceOverRunning: boolean; cdecl; external; { available starting in __MAC_NA,__IPHONE_4_0 }
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIAccessibilityVoiceOverStatusChanged: NSString { available starting in __MAC_NA,__IPHONE_4_0 }; cvar; external;
{$endif}

{$ifdef FUNCTIONS}
function UIAccessibilityIsMonoAudioEnabled: boolean; cdecl; external; { available starting in __MAC_NA,__IPHONE_5_0 }
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIAccessibilityMonoAudioStatusDidChangeNotification: NSString { available starting in __MAC_NA,__IPHONE_5_0 }; cvar; external;
{$endif}

{$ifdef FUNCTIONS}
function UIAccessibilityIsClosedCaptioningEnabled: boolean; cdecl; external; { available starting in __MAC_NA,__IPHONE_5_0 }
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIAccessibilityClosedCaptioningStatusDidChangeNotification: NSString { available starting in __MAC_NA,__IPHONE_5_0 }; cvar; external;
{$endif}

