{ Parsed from UIKit.framework (iPhoneOS5.0) UIActionSheet.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIActionSheetStyleAutomatic = -1;
  UIActionSheetStyleDefault = UIBarStyleDefault;
  UIActionSheetStyleBlackTranslucent = UIBarStyleBlackTranslucent;
  UIActionSheetStyleBlackOpaque = UIBarStyleBlackOpaque;
type
  UIActionSheetStyle = clong;
{$endif}

{$ifdef CLASSES}

type
  UIActionSheet = objcclass external (UIView)
  private
    _delegate: UIActionSheetDelegateProtocol;
    _titleLabel: UILabel;
    _subtitleLabel: UILabel;
    _bodyTextLabel: UILabel;
    _taglineTextLabel: UILabel;
    _startY: CGFloat;
    _context: id;
    _cancelButton: NSInteger;
    _defaultButton: NSInteger;
    _firstOtherButton: NSInteger;
    _toolbar: UIToolbar;
    _originalWindow: UIWindow;
    _dimWindow: UIWindow;
    _suspendTag: NSInteger;
    _dismissButtonIndex: NSInteger;
    _bodyTextHeight: CGFloat;
    _buttons: NSMutableArray;
    _buttonsInTable: NSMutableArray;
    _textFields: NSMutableArray;
    _keyboard: UIView;
    _table: UIView;
    _buttonTableView: UIView;
    _dimView: UIView;
    _popoverController: UIPopoverController;
    _fontSizeInTableView: CGFloat;
    _iconOffset: CGFloat;
    _labelOffset: CGFloat;
    _labelWidth: CGFloat;
    _titleWidth: CGFloat;
    _oldIgnoreTapsValue: boolean;
    _modalViewFlags: bitpacked record
      case byte of
        0: (_anonbitfield__modalViewFlags0: cuint);
        1: (
          numberOfRows: 0..((1 shl 7)-1);
          delegateAlertSheetButtonClicked: 0..1;
          delegateDidPresentAlertSheet: 0..1;
          delegateDidDismissAlertSheet: 0..1;
          hideButtonBar: 0..1;
          alertStyle: 0..((1 shl 3)-1);
          dontDimBackground: 0..1;
          dismissSuspended: 0..1;
          dontBlockInteraction: 0..1;
          sheetWasPoppedUp: 0..1;
          sheetWasShown: 0..1;
          animating: 0..1;
          hideWhenDoneAnimating: 0..1;
          layoutWhenDoneAnimating: 0..1;
          titleMaxLineCount: 0..((1 shl 2)-1);
          bodyTextMaxLineCount: 0..((1 shl 3)-1);
          runsModal: 0..1;
          runningModal: 0..1;
          addedTextView: 0..1;
          addedTableShadows: 0..1;
          showOverSBAlerts: 0..1;
          showMinTableContent: 0..1;
          bodyTextTruncated: 0..1;
          orientation: 0..((1 shl 3)-1);
          popupFromPoint: 0..1;
          inPopover: 0..1;
          delegateBodyTextAlignment: 0..1;
          delegateClickedButtonAtIndex: 0..1;
          delegateClickedButtonAtIndex2: 0..1;
          delegateCancel: 0..1;
          delegateCancel2: 0..1;
          delegateWillPresent: 0..1;
          delegateWillPresent2: 0..1;
          delegateDidPresent: 0..1;
          delegateDidPresent2: 0..1;
          delegateWillDismiss: 0..1;
          delegateWillDismiss2: 0..1;
          delegateDidDismiss: 0..1;
          delegateDidDismiss2: 0..1;
          dontCallDismissDelegate: 0..1;
          useAutomaticKB: 0..1;
          twoColumnsLayoutMode: 0..((1 shl 7)-1);
          threeColumnsLayoutMode: 0..((1 shl 7)-1);
          shouldHandleFirstKeyUpEvent: 0..1;
          cancelWhenDoneAnimating: 0..1;
          useThreePartButtons: 0..1;
          useTwoPartButtons: 0..1;
          displaySelectedButtonGlyph: 0..1;
          indexOfSelectedButton: 0..((1 shl 7)-1);
          useCustomSelectedButtonGlyph: 0..1;
        );
      end;
    _actionSheetStyle: UIActionSheetStyle;
    _selectedButtonGlyphImage: UIImage;
    _selectedButtonGlyphHighlightedImage: UIImage;
  public
    function initWithTitle_delegate_cancelButtonTitle_destructiveButtonTitle_otherButtonTitles (title: NSString; delegate: UIActionSheetDelegateProtocol; cancelButtonTitle: NSString; destructiveButtonTitle: NSString; otherButtonTitles: NSString): id; varargs; message 'initWithTitle:delegate:cancelButtonTitle:destructiveButtonTitle:otherButtonTitles:';
    procedure setDelegate(newValue: UIActionSheetDelegateProtocol); message 'setDelegate:';
    function delegate: UIActionSheetDelegateProtocol; message 'delegate';
    procedure setTitle(newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setActionSheetStyle(newValue: UIActionSheetStyle); message 'setActionSheetStyle:';
    function actionSheetStyle: UIActionSheetStyle; message 'actionSheetStyle';
    function addButtonWithTitle (title_: NSString): NSInteger; message 'addButtonWithTitle:';
    function buttonTitleAtIndex (buttonIndex: NSInteger): NSString; message 'buttonTitleAtIndex:';
    function numberOfButtons: NSInteger; message 'numberOfButtons';
    procedure setCancelButtonIndex(newValue: NSInteger); message 'setCancelButtonIndex:';
    function cancelButtonIndex: NSInteger; message 'cancelButtonIndex';
    procedure setDestructiveButtonIndex(newValue: NSInteger); message 'setDestructiveButtonIndex:';
    function destructiveButtonIndex: NSInteger; message 'destructiveButtonIndex';
    function firstOtherButtonIndex: NSInteger; message 'firstOtherButtonIndex';
    function isVisible: boolean; message 'isVisible';
    procedure showFromToolbar (view: UIToolbar); message 'showFromToolbar:';
    procedure showFromTabBar (view: UITabBar); message 'showFromTabBar:';
    procedure showFromBarButtonItem_animated (item: UIBarButtonItem; animated: boolean); message 'showFromBarButtonItem:animated:'; { available starting in __MAC_NA, __IPHONE_3_2 }
    procedure showFromRect_inView_animated (rect: CGRect; view: UIView; animated: boolean); message 'showFromRect:inView:animated:'; { available starting in __MAC_NA, __IPHONE_3_2 }
    procedure showInView (view: UIView); message 'showInView:';
    procedure dismissWithClickedButtonIndex_animated (buttonIndex: NSInteger; animated: boolean); message 'dismissWithClickedButtonIndex:animated:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIActionSheetDelegateProtocol = objcprotocol external name 'UIActionSheetDelegate'
  optional
    procedure actionSheet_clickedButtonAtIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:clickedButtonAtIndex:';
    procedure actionSheetCancel (actionSheet: UIActionSheet); message 'actionSheetCancel:';
    procedure willPresentActionSheet (actionSheet: UIActionSheet); message 'willPresentActionSheet:';
    procedure didPresentActionSheet (actionSheet: UIActionSheet); message 'didPresentActionSheet:';
    procedure actionSheet_willDismissWithButtonIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:willDismissWithButtonIndex:';
    procedure actionSheet_didDismissWithButtonIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:didDismissWithButtonIndex:';
  end;
{$endif}

