{ Parsed from UIKit.framework (iPhoneOS5.0) UIButton.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIButtonTypeCustom = 0;
  UIButtonTypeRoundedRect = 1;
  UIButtonTypeDetailDisclosure = 2;
  UIButtonTypeInfoLight = 3;
  UIButtonTypeInfoDark = 4;
  UIButtonTypeContactAdd = 5;
type
  UIButtonType = clong;
{$endif}

{$ifdef CLASSES}

type
  UIButton = objcclass external (UIControl, NSCodingProtocol)
  private
    _contentLookup: CFMutableDictionaryRef;
    _contentEdgeInsets: UIEdgeInsets;
    _titleEdgeInsets: UIEdgeInsets;
    _imageEdgeInsets: UIEdgeInsets;
    _backgroundView: UIImageView;
    _imageView: UIImageView;
    _titleView: UILabel;
    _initialized: boolean;
    _buttonFlags: bitpacked record
      case byte of
        0: (_anonbitfield__buttonFlags0: cuint);
        1: (
          reversesTitleShadowWhenHighlighted: 0..1;
          adjustsImageWhenHighlighted: 0..1;
          adjustsImageWhenDisabled: 0..1;
          autosizeToFit: 0..1;
          disabledDimsImage: 0..1;
          showsTouchWhenHighlighted: 0..1;
          buttonType: 0..((1 shl 8)-1);
          shouldHandleScrollerMouseEvent: 0..1;
        );
      end;
  public
    class function buttonWithType (buttonType: UIButtonType): id; message 'buttonWithType:';
    procedure setContentEdgeInsets(newValue: UIEdgeInsets); message 'setContentEdgeInsets:';
    function contentEdgeInsets: UIEdgeInsets; message 'contentEdgeInsets';
    procedure setTitleEdgeInsets(newValue: UIEdgeInsets); message 'setTitleEdgeInsets:';
    function titleEdgeInsets: UIEdgeInsets; message 'titleEdgeInsets';
    procedure setReversesTitleShadowWhenHighlighted(newValue: boolean); message 'setReversesTitleShadowWhenHighlighted:';
    function reversesTitleShadowWhenHighlighted: boolean; message 'reversesTitleShadowWhenHighlighted';
    procedure setImageEdgeInsets(newValue: UIEdgeInsets); message 'setImageEdgeInsets:';
    function imageEdgeInsets: UIEdgeInsets; message 'imageEdgeInsets';
    procedure setAdjustsImageWhenHighlighted(newValue: boolean); message 'setAdjustsImageWhenHighlighted:';
    function adjustsImageWhenHighlighted: boolean; message 'adjustsImageWhenHighlighted';
    procedure setAdjustsImageWhenDisabled(newValue: boolean); message 'setAdjustsImageWhenDisabled:';
    function adjustsImageWhenDisabled: boolean; message 'adjustsImageWhenDisabled';
    procedure setShowsTouchWhenHighlighted(newValue: boolean); message 'setShowsTouchWhenHighlighted:';
    function showsTouchWhenHighlighted: boolean; message 'showsTouchWhenHighlighted';
    procedure setTintColor(newValue: UIColor); message 'setTintColor:';
    function tintColor: UIColor; message 'tintColor';
    function buttonType: UIButtonType; message 'buttonType';
    procedure setTitle_forState (title: NSString; state_: UIControlState); message 'setTitle:forState:';
    procedure setTitleColor_forState (color: UIColor; state_: UIControlState); message 'setTitleColor:forState:';
    procedure setTitleShadowColor_forState (color: UIColor; state_: UIControlState); message 'setTitleShadowColor:forState:';
    procedure setImage_forState (image: UIImage; state_: UIControlState); message 'setImage:forState:';
    procedure setBackgroundImage_forState (image: UIImage; state_: UIControlState); message 'setBackgroundImage:forState:';
    function titleForState (state_: UIControlState): NSString; message 'titleForState:';
    function titleColorForState (state_: UIControlState): UIColor; message 'titleColorForState:';
    function titleShadowColorForState (state_: UIControlState): UIColor; message 'titleShadowColorForState:';
    function imageForState (state_: UIControlState): UIImage; message 'imageForState:';
    function backgroundImageForState (state_: UIControlState): UIImage; message 'backgroundImageForState:';
    function currentTitle: NSString; message 'currentTitle';
    function currentTitleColor: UIColor; message 'currentTitleColor';
    function currentTitleShadowColor: UIColor; message 'currentTitleShadowColor';
    function currentImage: UIImage; message 'currentImage';
    function currentBackgroundImage: UIImage; message 'currentBackgroundImage';
    function titleLabel: UILabel; message 'titleLabel';
    function imageView: UIImageView; message 'imageView';
    function backgroundRectForBounds (bounds: CGRect): CGRect; message 'backgroundRectForBounds:';
    function contentRectForBounds (bounds: CGRect): CGRect; message 'contentRectForBounds:';
    function titleRectForContentRect (contentRect: CGRect): CGRect; message 'titleRectForContentRect:';
    function imageRectForContentRect (contentRect: CGRect): CGRect; message 'imageRectForContentRect:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  UIButton_UIButtonDeprecated = objccategory external name 'UIButtonDeprecated' (UIButton)
    procedure setFont(newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setLineBreakMode(newValue: UILineBreakMode); message 'setLineBreakMode:';
    function lineBreakMode: UILineBreakMode; message 'lineBreakMode';
    procedure setTitleShadowOffset(newValue: CGSize); message 'setTitleShadowOffset:';
    function titleShadowOffset: CGSize; message 'titleShadowOffset';
  end;
{$endif}

