{ Parsed from UIKit.framework (iPhoneOS5.0) UIDocumentInteractionController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef CLASSES}

type
  UIDocumentInteractionController = objcclass external (NSObject, UIActionSheetDelegateProtocol)
  private
    _delegate: UIDocumentInteractionControllerDelegateProtocol;
    _previewItemProxy: id;
    _icons: NSArray;
    _annotation: id;
    _uniqueIdentifier: NSString;
    _popoverController: UIPopoverController;
    _presentingViewController: UIViewController;
    _previewController: id;
    _gestureRecognizers: NSArray;
    _presentRect: CGRect;
    _presentView: UIView;
    _presentItem: UIBarButtonItem;
    _availableApplications: NSArray;
    _openInViewController: UIViewController;
    _optionsMenu: UIActionSheet;
    _openInMenu: UIActionSheet;
    _quickLookButtonIndex: NSInteger;
    _defaultOpenButtonIndex: NSInteger;
    _alternateOpenButtonIndex: NSInteger;
    _copyButtonIndex: NSInteger;
    _printButtonIndex: NSInteger;
    _openInTableViewSize: CGSize;
    _shouldUnzipDocument: boolean;
    _unzippedDocumentURL: NSURL;
    _applicationToOpen: id;
    _documentInteractionControllerFlags: bitpacked record
      case byte of
        0: (_anonbitfield__documentInteractionControllerFlags0: cuint);
        1: (
          delegateViewControllerForPreview: 0..1;
          delegateRectForPreview: 0..1;
          delegateViewForPreview: 0..1;
          transitionImageForPreview: 0..1;
          delegateWillBeginPreview: 0..1;
          delegateDidEndPreviewPreview: 0..1;
          delegateWillPresentOptionsMenu: 0..1;
          delegateDidDismissOptionsMenu: 0..1;
          delegateWillPresentOpenInMenu: 0..1;
          delegateDidDismissOpenInMenu: 0..1;
          delegateWillBeginSendingToApplication: 0..1;
          delegateDidEndSendingToApplication: 0..1;
          delegateCanPerformAction: 0..1;
          delegatePerformAction: 0..1;
          delegateUnzipURL: 0..1;
        );
      end;
  public
    class function interactionControllerWithURL (url: NSURL): UIDocumentInteractionController; message 'interactionControllerWithURL:';
    procedure setDelegate(newValue: UIDocumentInteractionControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UIDocumentInteractionControllerDelegateProtocol; message 'delegate';
    procedure setURL(newValue: NSURL); message 'setURL:';
    function URL: NSURL; message 'URL';
    procedure setUTI(newValue: NSString); message 'setUTI:';
    function UTI: NSString; message 'UTI';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function icons: NSArray; message 'icons';
    procedure setAnnotation(newValue: id); message 'setAnnotation:';
    function annotation: id; message 'annotation';
    function presentOptionsMenuFromRect_inView_animated (rect: CGRect; view: UIView; animated: boolean): boolean; message 'presentOptionsMenuFromRect:inView:animated:';
    function presentOptionsMenuFromBarButtonItem_animated (item: UIBarButtonItem; animated: boolean): boolean; message 'presentOptionsMenuFromBarButtonItem:animated:';
    function presentPreviewAnimated (animated: boolean): boolean; message 'presentPreviewAnimated:';
    function presentOpenInMenuFromRect_inView_animated (rect: CGRect; view: UIView; animated: boolean): boolean; message 'presentOpenInMenuFromRect:inView:animated:';
    function presentOpenInMenuFromBarButtonItem_animated (item: UIBarButtonItem; animated: boolean): boolean; message 'presentOpenInMenuFromBarButtonItem:animated:';
    procedure dismissPreviewAnimated (animated: boolean); message 'dismissPreviewAnimated:';
    procedure dismissMenuAnimated (animated: boolean); message 'dismissMenuAnimated:';
    function gestureRecognizers: NSArray; message 'gestureRecognizers';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    procedure actionSheetCancel (actionSheet: UIActionSheet); message 'actionSheetCancel:';
    procedure didPresentActionSheet (actionSheet: UIActionSheet); message 'didPresentActionSheet:';
    procedure willPresentActionSheet (actionSheet: UIActionSheet); message 'willPresentActionSheet:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    procedure actionSheet_clickedButtonAtIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:clickedButtonAtIndex:';
    procedure actionSheet_didDismissWithButtonIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:didDismissWithButtonIndex:';
    procedure actionSheet_willDismissWithButtonIndex (actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:willDismissWithButtonIndex:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIDocumentInteractionControllerDelegateProtocol = objcprotocol external name 'UIDocumentInteractionControllerDelegate'
  optional
    function documentInteractionControllerViewControllerForPreview (controller: UIDocumentInteractionController): UIViewController; message 'documentInteractionControllerViewControllerForPreview:';
    function documentInteractionControllerRectForPreview (controller: UIDocumentInteractionController): CGRect; message 'documentInteractionControllerRectForPreview:';
    function documentInteractionControllerViewForPreview (controller: UIDocumentInteractionController): UIView; message 'documentInteractionControllerViewForPreview:';
    procedure documentInteractionControllerWillBeginPreview (controller: UIDocumentInteractionController); message 'documentInteractionControllerWillBeginPreview:';
    procedure documentInteractionControllerDidEndPreview (controller: UIDocumentInteractionController); message 'documentInteractionControllerDidEndPreview:';
    procedure documentInteractionControllerWillPresentOptionsMenu (controller: UIDocumentInteractionController); message 'documentInteractionControllerWillPresentOptionsMenu:';
    procedure documentInteractionControllerDidDismissOptionsMenu (controller: UIDocumentInteractionController); message 'documentInteractionControllerDidDismissOptionsMenu:';
    procedure documentInteractionControllerWillPresentOpenInMenu (controller: UIDocumentInteractionController); message 'documentInteractionControllerWillPresentOpenInMenu:';
    procedure documentInteractionControllerDidDismissOpenInMenu (controller: UIDocumentInteractionController); message 'documentInteractionControllerDidDismissOpenInMenu:';
    procedure documentInteractionController_willBeginSendingToApplication (controller: UIDocumentInteractionController; application: NSString); message 'documentInteractionController:willBeginSendingToApplication:';
    procedure documentInteractionController_didEndSendingToApplication (controller: UIDocumentInteractionController; application: NSString); message 'documentInteractionController:didEndSendingToApplication:';
    function documentInteractionController_canPerformAction (controller: UIDocumentInteractionController; action: SEL): boolean; message 'documentInteractionController:canPerformAction:';
    function documentInteractionController_performAction (controller: UIDocumentInteractionController; action: SEL): boolean; message 'documentInteractionController:performAction:';
  end;
{$endif}

