{ Parsed from UIKit.framework (iPhoneOS5.0) UIGestureRecognizer.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIGestureRecognizerStatePossible = 0;
  UIGestureRecognizerStateBegan = 1;
  UIGestureRecognizerStateChanged = 2;
  UIGestureRecognizerStateEnded = 3;
  UIGestureRecognizerStateCancelled = 4;
  UIGestureRecognizerStateFailed = 5;
  UIGestureRecognizerStateRecognized = UIGestureRecognizerStateEnded;
type
  UIGestureRecognizerState = clong;
{$endif}

{$ifdef CLASSES}

type
  UIGestureRecognizer = objcclass external (NSObject)
  private
    _targets: NSMutableArray;
    _delayedTouches: NSMutableArray;
    _view: UIView;
    _updateEvent: UIEvent;
    _delegate: UIGestureRecognizerDelegateProtocol;
    _failureRequirements: NSMutableSet;
    _failureDependents: NSMutableSet;
    _dynamicFailureRequirements: NSMutableSet;
    _dynamicFailureDependents: NSMutableSet;
    _failureMap: id;
    _friends: NSMutableSet;
    _state: UIGestureRecognizerState;
    _gestureFlags: bitpacked record
      case byte of
        0: (_anonbitfield__gestureFlags0: cuint);
        1: (
          delegateShouldBegin: 0..1;
          delegateCanPrevent: 0..1;
          delegateCanBePrevented: 0..1;
          delegateShouldRecognizeSimultaneously: 0..1;
          delegateShouldReceiveTouch: 0..1;
          delegateShouldRequireFailure: 0..1;
          delegateShouldBeRequiredToFail: 0..1;
          delegateFailed: 0..1;
          privateDelegateShouldBegin: 0..1;
          privateDelegateShouldRecognizeSimultaneously: 0..1;
          privateDelegateShouldReceiveTouch: 0..1;
          subclassShouldRequireFailure: 0..1;
          cancelsTouchesInView: 0..1;
          delaysTouchesBegan: 0..1;
          delaysTouchesEnded: 0..1;
          notExclusive: 0..1;
          disabled: 0..1;
          dirty: 0..1;
          queriedFailureRequirements: 0..1;
          delivered: 0..1;
          continuous: 0..1;
          requiresDelayedBegan: 0..1;
        );
      end;
  public
    function initWithTarget_action (target: id; action: SEL): id; message 'initWithTarget:action:';
    procedure addTarget_action (target: id; action: SEL); message 'addTarget:action:';
    procedure removeTarget_action (target: id; action: SEL); message 'removeTarget:action:';
    function state: UIGestureRecognizerState; message 'state';
    procedure setDelegate(newValue: UIGestureRecognizerDelegateProtocol); message 'setDelegate:';
    function delegate: UIGestureRecognizerDelegateProtocol; message 'delegate';
    procedure setEnabled(newValue: boolean); message 'setEnabled:';
    function isEnabled: boolean; message 'isEnabled';
    function view: UIView; message 'view';
    procedure setCancelsTouchesInView(newValue: boolean); message 'setCancelsTouchesInView:';
    function cancelsTouchesInView: boolean; message 'cancelsTouchesInView';
    procedure setDelaysTouchesBegan(newValue: boolean); message 'setDelaysTouchesBegan:';
    function delaysTouchesBegan: boolean; message 'delaysTouchesBegan';
    procedure setDelaysTouchesEnded(newValue: boolean); message 'setDelaysTouchesEnded:';
    function delaysTouchesEnded: boolean; message 'delaysTouchesEnded';
    procedure requireGestureRecognizerToFail (otherGestureRecognizer: UIGestureRecognizer); message 'requireGestureRecognizerToFail:';
    function locationInView (view_: UIView): CGPoint; message 'locationInView:';
    function numberOfTouches: NSUInteger; message 'numberOfTouches';
    function locationOfTouch_inView (touchIndex: NSUInteger; view_: UIView): CGPoint; message 'locationOfTouch:inView:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIGestureRecognizerDelegateProtocol = objcprotocol external name 'UIGestureRecognizerDelegate'
  optional
    function gestureRecognizerShouldBegin (gestureRecognizer: UIGestureRecognizer): boolean; message 'gestureRecognizerShouldBegin:';
    function gestureRecognizer_shouldRecognizeSimultaneouslyWithGestureRecognizer (gestureRecognizer: UIGestureRecognizer; otherGestureRecognizer: UIGestureRecognizer): boolean; message 'gestureRecognizer:shouldRecognizeSimultaneouslyWithGestureRecognizer:';
    function gestureRecognizer_shouldReceiveTouch (gestureRecognizer: UIGestureRecognizer; touch: UITouch): boolean; message 'gestureRecognizer:shouldReceiveTouch:';
  end;
{$endif}

