{ Parsed from UIKit.framework (iPhoneOS5.0) UIImagePickerController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIImagePickerControllerSourceTypePhotoLibrary = 0;
  UIImagePickerControllerSourceTypeCamera = 1;
  UIImagePickerControllerSourceTypeSavedPhotosAlbum = 2;

type
  UIImagePickerControllerSourceType = NSUInteger;
  UIImagePickerControllerSourceTypePtr = ^UIImagePickerControllerSourceType;

const
  UIImagePickerControllerQualityTypeHigh = 0;
  UIImagePickerControllerQualityTypeMedium = 1;
  UIImagePickerControllerQualityTypeLow = 2;
  {$if (__IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_4_0)}
  UIImagePickerControllerQualityType640x480 = 3;
  {$endif}
  {$if (__IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_5_0)}
  UIImagePickerControllerQualityTypeIFrame1280x720 = 4;
  UIImagePickerControllerQualityTypeIFrame960x540 = 5;
  {$endif}

type
  UIImagePickerControllerQualityType = NSUInteger;
  UIImagePickerControllerQualityTypePtr = ^UIImagePickerControllerQualityType;

const
  UIImagePickerControllerCameraCaptureModePhoto = 0;
  UIImagePickerControllerCameraCaptureModeVideo = 1;

type
  UIImagePickerControllerCameraCaptureMode = NSUInteger;
  UIImagePickerControllerCameraCaptureModePtr = ^UIImagePickerControllerCameraCaptureMode;

const
  UIImagePickerControllerCameraDeviceRear = 0;
  UIImagePickerControllerCameraDeviceFront = 1;

type
  UIImagePickerControllerCameraDevice = NSUInteger;
  UIImagePickerControllerCameraDevicePtr = ^UIImagePickerControllerCameraDevice;

const
  UIImagePickerControllerCameraFlashModeOff = -1;
  UIImagePickerControllerCameraFlashModeAuto = 0;
  UIImagePickerControllerCameraFlashModeOn = 1;

type
  UIImagePickerControllerCameraFlashMode = NSInteger;
  UIImagePickerControllerCameraFlashModePtr = ^UIImagePickerControllerCameraFlashMode;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIImagePickerControllerMediaType: NSString; cvar; external;
  UIImagePickerControllerOriginalImage: NSString; cvar; external;
  UIImagePickerControllerEditedImage: NSString; cvar; external;
  UIImagePickerControllerCropRect: NSString; cvar; external;
  UIImagePickerControllerMediaURL: NSString; cvar; external;
  UIImagePickerControllerReferenceURL: NSString { available starting in __MAC_NA,__IPHONE_4_1 }; cvar; external;
  UIImagePickerControllerMediaMetadata: NSString { available starting in __MAC_NA,__IPHONE_4_1 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  UIImagePickerController = objcclass external (UINavigationController, NSCodingProtocol)
  private
    _sourceType: UIImagePickerControllerSourceType;
    _image: id;
    _cropRect: CGRect;
    _mediaTypes: NSArray;
    _properties: NSMutableDictionary;
    _previousStatusBarStyle: cint;
    _imagePickerFlags: bitpacked record
      case byte of
        0: (_anonbitfield__imagePickerFlags0: cuint);
        1: (
          visible: 0..1;
          isCleaningUp: 0..1;
          savingOptions: 0..((1 shl 3)-1);
          didRevertStatusBar: 0..1;
        );
      end;
  public
    class function isSourceTypeAvailable (sourceType: UIImagePickerControllerSourceType): boolean; message 'isSourceTypeAvailable:';
    class function availableMediaTypesForSourceType (sourceType: UIImagePickerControllerSourceType): NSArray; message 'availableMediaTypesForSourceType:';
    class function isCameraDeviceAvailable (cameraDevice: UIImagePickerControllerCameraDevice): boolean; message 'isCameraDeviceAvailable:'; { available starting in __MAC_NA,__IPHONE_4_0 }
    class function isFlashAvailableForCameraDevice (cameraDevice: UIImagePickerControllerCameraDevice): boolean; message 'isFlashAvailableForCameraDevice:'; { available starting in __MAC_NA,__IPHONE_4_0 }
    class function availableCaptureModesForCameraDevice (cameraDevice: UIImagePickerControllerCameraDevice): NSArray; message 'availableCaptureModesForCameraDevice:'; { available starting in __MAC_NA,__IPHONE_4_0 }
    procedure setDelegate_(newValue: id); message 'setDelegate:';
    function delegate_: id; message 'delegate';
    procedure setSourceType(newValue: UIImagePickerControllerSourceType); message 'setSourceType:';
    function sourceType: UIImagePickerControllerSourceType; message 'sourceType';
    procedure setMediaTypes(newValue: NSArray); message 'setMediaTypes:';
    function mediaTypes: NSArray; message 'mediaTypes';
    procedure setAllowsEditing(newValue: boolean); message 'setAllowsEditing:';
    function allowsEditing: boolean; message 'allowsEditing';
    procedure setAllowsImageEditing(newValue: boolean); message 'setAllowsImageEditing:';
    function allowsImageEditing: boolean; message 'allowsImageEditing';
    procedure setVideoMaximumDuration(newValue: NSTimeInterval); message 'setVideoMaximumDuration:';
    function videoMaximumDuration: NSTimeInterval; message 'videoMaximumDuration';
    procedure setVideoQuality(newValue: UIImagePickerControllerQualityType); message 'setVideoQuality:';
    function videoQuality: UIImagePickerControllerQualityType; message 'videoQuality';
    procedure setShowsCameraControls(newValue: boolean); message 'setShowsCameraControls:';
    function showsCameraControls: boolean; message 'showsCameraControls';
    procedure setCameraOverlayView(newValue: UIView); message 'setCameraOverlayView:';
    function cameraOverlayView: UIView; message 'cameraOverlayView';
    procedure setCameraViewTransform(newValue: CGAffineTransform); message 'setCameraViewTransform:';
    function cameraViewTransform: CGAffineTransform; message 'cameraViewTransform';
    procedure takePicture; message 'takePicture'; { available starting in __MAC_NA,__IPHONE_3_1 }
    function startVideoCapture: boolean; message 'startVideoCapture'; { available starting in __MAC_NA,__IPHONE_4_0 }
    procedure stopVideoCapture; message 'stopVideoCapture'; { available starting in __MAC_NA,__IPHONE_4_0 }
    procedure setCameraCaptureMode(newValue: UIImagePickerControllerCameraCaptureMode); message 'setCameraCaptureMode:';
    function cameraCaptureMode: UIImagePickerControllerCameraCaptureMode; message 'cameraCaptureMode';
    procedure setCameraDevice(newValue: UIImagePickerControllerCameraDevice); message 'setCameraDevice:';
    function cameraDevice: UIImagePickerControllerCameraDevice; message 'cameraDevice';
    procedure setCameraFlashMode(newValue: UIImagePickerControllerCameraFlashMode); message 'setCameraFlashMode:';
    function cameraFlashMode: UIImagePickerControllerCameraFlashMode; message 'cameraFlashMode';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIImagePickerControllerDelegateProtocol = objcprotocol external name 'UIImagePickerControllerDelegate'
  optional
    procedure imagePickerController_didFinishPickingImage_editingInfo (picker: UIImagePickerController; image: UIImage; editingInfo: NSDictionary); message 'imagePickerController:didFinishPickingImage:editingInfo:'; deprecated 'in __MAC_NA,__MAC_NA,__IPHONE_2_0,__IPHONE_3_0';
    procedure imagePickerController_didFinishPickingMediaWithInfo (picker: UIImagePickerController; info: NSDictionary); message 'imagePickerController:didFinishPickingMediaWithInfo:';
    procedure imagePickerControllerDidCancel (picker: UIImagePickerController); message 'imagePickerControllerDidCancel:';
  end;
{$endif}

{$ifdef FUNCTIONS}
function UIImageWriteToSavedPhotosAlbum(image: UIImage; completionTarget: id; completionSelector: SEL; contextInfo: pointer): pointer; cdecl; external;
function UIVideoAtPathIsCompatibleWithSavedPhotosAlbum(videoPath: NSString): boolean; cdecl; external; { available starting in __MAC_NA,__IPHONE_3_1 }
function UISaveVideoAtPathToSavedPhotosAlbum(videoPath: NSString; completionTarget: id; completionSelector: SEL; contextInfo: pointer): pointer; cdecl; external; { available starting in __MAC_NA,__IPHONE_3_1 }
{$endif}

