{ Parsed from UIKit.framework (iPhoneOS5.0) UIMenuController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIMenuControllerArrowDefault = 0;
  {$if (__IPHONE_3_2 <= __IPHONE_OS_VERSION_MAX_ALLOWED)}
  UIMenuControllerArrowUp = 1;
  UIMenuControllerArrowDown = 2;
  UIMenuControllerArrowLeft = 3;
  UIMenuControllerArrowRight = 4;
  {$endif}
type
  UIMenuControllerArrowDirection = clong;
{$endif}

{$ifdef CLASSES}

type
  UIMenuController = objcclass external (NSObject)
  private
    _targetRect: CGRect;
    _arrowDirection: UIMenuControllerArrowDirection;
  public
    class function sharedMenuController: UIMenuController; message 'sharedMenuController';
    procedure setMenuVisible(newValue: boolean); message 'setMenuVisible:';
    function isMenuVisible: boolean; message 'isMenuVisible';
    procedure setMenuVisible_animated (menuVisible: boolean; animated: boolean); message 'setMenuVisible:animated:';
    procedure setTargetRect_inView (targetRect: CGRect; targetView: UIView); message 'setTargetRect:inView:';
    procedure setArrowDirection(newValue: UIMenuControllerArrowDirection); message 'setArrowDirection:';
    function arrowDirection: UIMenuControllerArrowDirection; message 'arrowDirection';
    procedure setMenuItems(newValue: NSArray); message 'setMenuItems:';
    function menuItems: NSArray; message 'menuItems';
    procedure update; message 'update';
    function menuFrame: CGRect; message 'menuFrame';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIMenuControllerWillShowMenuNotification: NSString; cvar; external;
  UIMenuControllerDidShowMenuNotification: NSString; cvar; external;
  UIMenuControllerWillHideMenuNotification: NSString; cvar; external;
  UIMenuControllerDidHideMenuNotification: NSString; cvar; external;
  UIMenuControllerMenuFrameDidChangeNotification: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  UIMenuItem = objcclass external (NSObject)
  private
    _title: NSString;
    _action: SEL;
    _dontDismiss: boolean;
  public
    function initWithTitle_action (title: NSString; action: SEL): id; message 'initWithTitle:action:';
    procedure setTitle(newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setAction(newValue: SEL); message 'setAction:';
    function action: SEL; message 'action';
  end;
{$endif}

