{ Parsed from UIKit.framework (iPhoneOS5.0) UIPopoverController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIPopoverArrowDirectionUp = 1 shl 0;
  UIPopoverArrowDirectionDown = 1 shl 1;
  UIPopoverArrowDirectionLeft = 1 shl 2;
  UIPopoverArrowDirectionRight = 1 shl 3;
  UIPopoverArrowDirectionAny = UIPopoverArrowDirectionUp + UIPopoverArrowDirectionDown + UIPopoverArrowDirectionLeft + UIPopoverArrowDirectionRight;
  UIPopoverArrowDirectionUnknown = NSUIntegerMax;

type
  UIPopoverArrowDirection = NSUInteger;
  UIPopoverArrowDirectionPtr = ^UIPopoverArrowDirection;
{$endif}

{$ifdef CLASSES}

type
  UIPopoverController = objcclass external (NSObject, UIAppearanceContainerProtocol)
  private
  public
    function initWithContentViewController (viewController: UIViewController): id; message 'initWithContentViewController:';
    procedure setDelegate(newValue: UIPopoverControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UIPopoverControllerDelegateProtocol; message 'delegate';
    procedure setContentViewController(newValue: UIViewController); message 'setContentViewController:';
    function contentViewController: UIViewController; message 'contentViewController';
    procedure setContentViewController_animated (viewController: UIViewController; animated: boolean); message 'setContentViewController:animated:';
    procedure setPopoverContentSize(newValue: CGSize); message 'setPopoverContentSize:';
    function popoverContentSize: CGSize; message 'popoverContentSize';
    procedure setPopoverContentSize_animated (size: CGSize; animated: boolean); message 'setPopoverContentSize:animated:';
    function isPopoverVisible: boolean; message 'isPopoverVisible';
    function popoverArrowDirection: UIPopoverArrowDirection; message 'popoverArrowDirection';
    procedure setPassthroughViews(newValue: NSArray); message 'setPassthroughViews:';
    function passthroughViews: NSArray; message 'passthroughViews';
    procedure presentPopoverFromRect_inView_permittedArrowDirections_animated (rect: CGRect; view: UIView; arrowDirections: UIPopoverArrowDirection; animated: boolean); message 'presentPopoverFromRect:inView:permittedArrowDirections:animated:';
    procedure presentPopoverFromBarButtonItem_permittedArrowDirections_animated (item: UIBarButtonItem; arrowDirections: UIPopoverArrowDirection; animated: boolean); message 'presentPopoverFromBarButtonItem:permittedArrowDirections:animated:';
    procedure dismissPopoverAnimated (animated: boolean); message 'dismissPopoverAnimated:';
    procedure setPopoverLayoutMargins(newValue: UIEdgeInsets); message 'setPopoverLayoutMargins:';
    function popoverLayoutMargins: UIEdgeInsets; message 'popoverLayoutMargins';
    procedure setPopoverBackgroundViewClass(newValue: pobjc_class); message 'setPopoverBackgroundViewClass:';
    function popoverBackgroundViewClass: pobjc_class; message 'popoverBackgroundViewClass';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIPopoverControllerDelegateProtocol = objcprotocol external name 'UIPopoverControllerDelegate'
  optional
    function popoverControllerShouldDismissPopover (popoverController: UIPopoverController): boolean; message 'popoverControllerShouldDismissPopover:';
    procedure popoverControllerDidDismissPopover (popoverController: UIPopoverController); message 'popoverControllerDidDismissPopover:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UIViewController_UIPopoverController = objccategory external name 'UIPopoverController' (UIViewController)
    procedure setContentSizeForViewInPopover(newValue: CGSize); message 'setContentSizeForViewInPopover:';
    function contentSizeForViewInPopover: CGSize; message 'contentSizeForViewInPopover';
    procedure setModalInPopover(newValue: boolean); message 'setModalInPopover:';
    function isModalInPopover: boolean; message 'isModalInPopover';
  end;
{$endif}

