{ Parsed from UIKit.framework (iPhoneOS5.0) UIScrollView.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIScrollViewIndicatorStyleDefault = 0;
  UIScrollViewIndicatorStyleBlack = 1;
  UIScrollViewIndicatorStyleWhite = 2;
type
  UIScrollViewIndicatorStyle = clong;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIScrollViewDecelerationRateNormal: single { available starting in __MAC_NA,__IPHONE_3_0 }; cvar; external;
  UIScrollViewDecelerationRateFast: single { available starting in __MAC_NA,__IPHONE_3_0 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  UIScrollView = objcclass external (UIView, NSCodingProtocol)
  private
    _contentSize: CGSize;
    _contentInset: UIEdgeInsets;
    _delegate: id;
    _verticalScrollIndicator: UIImageView;
    _horizontalScrollIndicator: UIImageView;
    _scrollIndicatorInset: UIEdgeInsets;
    _scrollViewFlags: bitpacked record
      case byte of
        0: (_anonbitfield__scrollViewFlags0: cuint);
        1: (
          tracking: 0..1;
          dragging: 0..1;
          verticalBounceEnabled: 0..1;
          horizontalBounceEnabled: 0..1;
          verticalBouncing: 0..1;
          horizontalBouncing: 0..1;
          bouncesZoom: 0..1;
          zoomBouncing: 0..1;
          alwaysBounceHorizontal: 0..1;
          alwaysBounceVertical: 0..1;
          canCancelContentTouches: 0..1;
          delaysContentTouches: 0..1;
          programmaticScrollDisabled: 0..1;
          scrollDisabled: 0..1;
          zoomDisabled: 0..1;
          scrollTriggered: 0..1;
          scrollDisabledOnTouchBegan: 0..1;
          ignoreNextTouchesMoved: 0..1;
          cancelNextContentTouchEnded: 0..1;
          inContentViewCall: 0..1;
          dontSelect: 0..1;
          contentTouched: 0..1;
          cantCancel: 0..1;
          directionalLockEnabled: 0..1;
          directionalLockAutoEnabled: 0..1;
          lockVertical: 0..1;
          lockHorizontal: 0..1;
          keepLocked: 0..1;
          showsHorizontalScrollIndicator: 0..1;
          showsVerticalScrollIndicator: 0..1;
          indicatorStyle: 0..((1 shl 2)-1);
          inZoom: 0..1;
          hideIndicatorsInZoom: 0..1;
          pushedTrackingMode: 0..1;
          multipleDrag: 0..1;
          displayingScrollIndicators: 0..1;
          verticalIndicatorShrunk: 0..1;
          horizontalIndicatorShrunk: 0..1;
          contentFitDisableScrolling: 0..1;
          pagingEnabled: 0..1;
          pagingLeft: 0..1;
          pagingRight: 0..1;
          pagingUp: 0..1;
          pagingDown: 0..1;
          lastHorizontalDirection: 0..1;
          lastVerticalDirection: 0..1;
          dontScrollToTop: 0..1;
          scrollingToTop: 0..1;
          useGestureRecognizers: 0..1;
          autoscrolling: 0..1;
          automaticContentOffsetAdjustmentDisabled: 0..1;
          skipStartOffsetAdjustment: 0..1;
          delegateScrollViewDidScroll: 0..1;
          delegateScrollViewDidZoom: 0..1;
          delegateContentSizeForZoomScale: 0..1;
          preserveCenterDuringRotation: 0..1;
          delaysTrackingWhileDecelerating: 0..1;
          pinnedZoomMin: 0..1;
          pinnedXMin: 0..1;
          pinnedYMin: 0..1;
          pinnedXMax: 0..1;
          pinnedYMax: 0..1;
          skipLinkChecks: 0..1;
          staysCenteredDuringPinch: 0..1;
          wasDelayingPinchForSystemGestures: 0..1;
          systemGesturesRecognitionPossible: 0..1;
          disableContentOffsetRounding: 0..1;
          adjustedDecelerationTargetX: 0..1;
          adjustedDecelerationTargetY: 0..1;
        );
      end;
    _farthestDistance: CGFloat;
    _initialTouchPosition: CGPoint;
    _startTouchPosition: CGPoint;
    _startTouchTime: CFTimeInterval;
    _startOffsetX: double;
    _startOffsetY: double;
    _lastUpdateOffsetX: double;
    _lastUpdateOffsetY: double;
    _lastTouchPosition: CGPoint;
    _lastTouchTime: CFTimeInterval;
    _lastUpdateTime: CFTimeInterval;
    _contentView: UIView;
    _minimumZoomScale: single;
    _maximumZoomScale: single;
    _zoomView: UIView;
    _horizontalVelocity: double;
    _verticalVelocity: double;
    _previousHorizontalVelocity: double;
    _previousVerticalVelocity: double;
    _scrollHeartbeat: CFTypeRef;
    _pageDecelerationTarget: CGPoint;
    _decelerationFactor: CGSize;
    _adjustedDecelerationTarget: CGPoint;
    _adjustedDecelerationFactor: CGSize;
    _decelerationLnFactorH: double;
    _decelerationLnFactorV: double;
    _deferredBeginTouchesInfo: NSArray;
    _shadows: UIImageViewPtr;
    _scrollNotificationViews: id;
    _contentOffsetAnimationDuration: CFTimeInterval;
    _animation: id;
    _pinch: id;
    _pan: id;
    _swipe: id;
    _pagingSpringPull: CGFloat;
    _pagingFriction: CGFloat;
    _fastScrollCount: NSInteger;
    _fastScrollMultiplier: CGFloat;
    _fastScrollStartMultiplier: CGFloat;
    _fastScrollEndTime: CFTimeInterval;
    _parentAdjustment: CGPoint;
    _rotationCenterPoint: CGPoint;
    _accuracy: CGFloat;
    _hysteresis: CGFloat;
    _zoomAnimationCount: NSUInteger;
  public
    procedure setContentOffset(newValue: CGPoint); message 'setContentOffset:';
    function contentOffset: CGPoint; message 'contentOffset';
    procedure setContentSize(newValue: CGSize); message 'setContentSize:';
    function contentSize: CGSize; message 'contentSize';
    procedure setContentInset(newValue: UIEdgeInsets); message 'setContentInset:';
    function contentInset: UIEdgeInsets; message 'contentInset';
    procedure setDelegate(newValue: UIScrollViewDelegateProtocol); message 'setDelegate:';
    function delegate: UIScrollViewDelegateProtocol; message 'delegate';
    procedure setDirectionalLockEnabled(newValue: boolean); message 'setDirectionalLockEnabled:';
    function isDirectionalLockEnabled: boolean; message 'isDirectionalLockEnabled';
    procedure setBounces(newValue: boolean); message 'setBounces:';
    function bounces: boolean; message 'bounces';
    procedure setAlwaysBounceVertical(newValue: boolean); message 'setAlwaysBounceVertical:';
    function alwaysBounceVertical: boolean; message 'alwaysBounceVertical';
    procedure setAlwaysBounceHorizontal(newValue: boolean); message 'setAlwaysBounceHorizontal:';
    function alwaysBounceHorizontal: boolean; message 'alwaysBounceHorizontal';
    procedure setPagingEnabled(newValue: boolean); message 'setPagingEnabled:';
    function isPagingEnabled: boolean; message 'isPagingEnabled';
    procedure setScrollEnabled(newValue: boolean); message 'setScrollEnabled:';
    function isScrollEnabled: boolean; message 'isScrollEnabled';
    procedure setShowsHorizontalScrollIndicator(newValue: boolean); message 'setShowsHorizontalScrollIndicator:';
    function showsHorizontalScrollIndicator: boolean; message 'showsHorizontalScrollIndicator';
    procedure setShowsVerticalScrollIndicator(newValue: boolean); message 'setShowsVerticalScrollIndicator:';
    function showsVerticalScrollIndicator: boolean; message 'showsVerticalScrollIndicator';
    procedure setScrollIndicatorInsets(newValue: UIEdgeInsets); message 'setScrollIndicatorInsets:';
    function scrollIndicatorInsets: UIEdgeInsets; message 'scrollIndicatorInsets';
    procedure setIndicatorStyle(newValue: UIScrollViewIndicatorStyle); message 'setIndicatorStyle:';
    function indicatorStyle: UIScrollViewIndicatorStyle; message 'indicatorStyle';
    procedure setDecelerationRate(newValue: single); message 'setDecelerationRate:';
    function decelerationRate: single; message 'decelerationRate';
    procedure setContentOffset_animated (contentOffset_: CGPoint; animated: boolean); message 'setContentOffset:animated:';
    procedure scrollRectToVisible_animated (rect: CGRect; animated: boolean); message 'scrollRectToVisible:animated:';
    procedure flashScrollIndicators; message 'flashScrollIndicators';
    function isTracking: boolean; message 'isTracking';
    function isDragging: boolean; message 'isDragging';
    function isDecelerating: boolean; message 'isDecelerating';
    procedure setDelaysContentTouches(newValue: boolean); message 'setDelaysContentTouches:';
    function delaysContentTouches: boolean; message 'delaysContentTouches';
    procedure setCanCancelContentTouches(newValue: boolean); message 'setCanCancelContentTouches:';
    function canCancelContentTouches: boolean; message 'canCancelContentTouches';
    function touchesShouldBegin_withEvent_inContentView (touches: NSSet; event: UIEvent; view: UIView): boolean; message 'touchesShouldBegin:withEvent:inContentView:';
    function touchesShouldCancelInContentView (view: UIView): boolean; message 'touchesShouldCancelInContentView:';
    procedure setMinimumZoomScale(newValue: single); message 'setMinimumZoomScale:';
    function minimumZoomScale: single; message 'minimumZoomScale';
    procedure setMaximumZoomScale(newValue: single); message 'setMaximumZoomScale:';
    function maximumZoomScale: single; message 'maximumZoomScale';
    procedure setZoomScale(newValue: single); message 'setZoomScale:';
    function zoomScale: single; message 'zoomScale';
    procedure setZoomScale_animated (scale: single; animated: boolean); message 'setZoomScale:animated:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure zoomToRect_animated (rect: CGRect; animated: boolean); message 'zoomToRect:animated:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure setBouncesZoom(newValue: boolean); message 'setBouncesZoom:';
    function bouncesZoom: boolean; message 'bouncesZoom';
    function isZooming: boolean; message 'isZooming';
    function isZoomBouncing: boolean; message 'isZoomBouncing';
    procedure setScrollsToTop(newValue: boolean); message 'setScrollsToTop:';
    function scrollsToTop: boolean; message 'scrollsToTop';
    function panGestureRecognizer: UIPanGestureRecognizer; message 'panGestureRecognizer';
    function pinchGestureRecognizer: UIPinchGestureRecognizer; message 'pinchGestureRecognizer';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIScrollViewDelegateProtocol = objcprotocol external name 'UIScrollViewDelegate'
  optional
    procedure scrollViewDidScroll (scrollView: UIScrollView); message 'scrollViewDidScroll:';
    procedure scrollViewDidZoom (scrollView: UIScrollView); message 'scrollViewDidZoom:'; { available starting in __MAC_NA,__IPHONE_3_2 }
    procedure scrollViewWillBeginDragging (scrollView: UIScrollView); message 'scrollViewWillBeginDragging:';
    procedure scrollViewWillEndDragging_withVelocity_targetContentOffset (scrollView: UIScrollView; velocity: CGPoint; targetContentOffset: CGPointPtr); message 'scrollViewWillEndDragging:withVelocity:targetContentOffset:'; { available starting in __MAC_NA,__IPHONE_5_0 }
    procedure scrollViewDidEndDragging_willDecelerate (scrollView: UIScrollView; decelerate: boolean); message 'scrollViewDidEndDragging:willDecelerate:';
    procedure scrollViewWillBeginDecelerating (scrollView: UIScrollView); message 'scrollViewWillBeginDecelerating:';
    procedure scrollViewDidEndDecelerating (scrollView: UIScrollView); message 'scrollViewDidEndDecelerating:';
    procedure scrollViewDidEndScrollingAnimation (scrollView: UIScrollView); message 'scrollViewDidEndScrollingAnimation:';
    function viewForZoomingInScrollView (scrollView: UIScrollView): UIView; message 'viewForZoomingInScrollView:';
    procedure scrollViewWillBeginZooming_withView (scrollView: UIScrollView; view: UIView); message 'scrollViewWillBeginZooming:withView:'; { available starting in __MAC_NA,__IPHONE_3_2 }
    procedure scrollViewDidEndZooming_withView_atScale (scrollView: UIScrollView; view: UIView; scale: single); message 'scrollViewDidEndZooming:withView:atScale:';
    function scrollViewShouldScrollToTop (scrollView: UIScrollView): boolean; message 'scrollViewShouldScrollToTop:';
    procedure scrollViewDidScrollToTop (scrollView: UIScrollView); message 'scrollViewDidScrollToTop:';
  end;
{$endif}

