{ Parsed from UIKit.framework (iPhoneOS5.0) UISearchDisplayController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef CLASSES}

type
  UISearchDisplayController = objcclass external (NSObject)
  private
    _viewController: UIViewController;
    _tableView: UITableView;
    _dimmingView: UIView;
    _searchBar: UISearchBar;
    _noResultsLabel: UILabel;
    _noResultsMessage: NSString;
    _resultsTitle: NSString;
    _delegate: UISearchDisplayDelegateProtocol;
    _tableViewDataSource: UITableViewDataSourceProtocol;
    _tableViewDelegate: UITableViewDelegateProtocol;
    _containingScrollViews: CFMutableArrayRef;
    _lastKeyboardAdjustment: CGFloat;
    _lastFooterAdjustment: CGFloat;
    _popoverController: UIPopoverController;
    _searchResultsTableViewStyle: UITableViewStyle;
    _navigationControllerBookkeeper: id;
    _searchDisplayControllerFlags: bitpacked record
      case byte of
        0: (_anonbitfield__searchDisplayControllerFlags0: cuint);
        1: (
          visible: 0..1;
          animating: 0..1;
          hidIndexBar: 0..1;
          hidNavigationBar: 0..1;
          noResultsMessageVisible: 0..1;
          noResultsMessageAutoDisplay: 0..1;
          navigationBarHidingEnabled: 0..1;
          dimTableViewOnEmptySearchString: 0..1;
          isRotatingWithPopover: 0..1;
          cancelButtonManagementDisabled: 0..1;
          allowDisablingNavigationBarHiding: 0..1;
        );
      end;
  public
    function initWithSearchBar_contentsController (searchBar: UISearchBar; viewController: UIViewController): id; message 'initWithSearchBar:contentsController:';
    procedure setDelegate(newValue: UISearchDisplayDelegateProtocol); message 'setDelegate:';
    function delegate: UISearchDisplayDelegateProtocol; message 'delegate';
    procedure setActive(newValue: boolean); message 'setActive:';
    function isActive: boolean; message 'isActive';
    procedure setActive_animated (visible: boolean; animated: boolean); message 'setActive:animated:';
    function searchBar: UISearchBar; message 'searchBar';
    function searchContentsController: UIViewController; message 'searchContentsController';
    function searchResultsTableView: UITableView; message 'searchResultsTableView';
    procedure setSearchResultsDataSource(newValue: UITableViewDataSourceProtocol); message 'setSearchResultsDataSource:';
    function searchResultsDataSource: UITableViewDataSourceProtocol; message 'searchResultsDataSource';
    procedure setSearchResultsDelegate(newValue: UITableViewDelegateProtocol); message 'setSearchResultsDelegate:';
    function searchResultsDelegate: UITableViewDelegateProtocol; message 'searchResultsDelegate';
    procedure setSearchResultsTitle(newValue: NSString); message 'setSearchResultsTitle:';
    function searchResultsTitle: NSString; message 'searchResultsTitle';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UISearchDisplayDelegateProtocol = objcprotocol external name 'UISearchDisplayDelegate'
  optional
    procedure searchDisplayControllerWillBeginSearch (controller: UISearchDisplayController); message 'searchDisplayControllerWillBeginSearch:';
    procedure searchDisplayControllerDidBeginSearch (controller: UISearchDisplayController); message 'searchDisplayControllerDidBeginSearch:';
    procedure searchDisplayControllerWillEndSearch (controller: UISearchDisplayController); message 'searchDisplayControllerWillEndSearch:';
    procedure searchDisplayControllerDidEndSearch (controller: UISearchDisplayController); message 'searchDisplayControllerDidEndSearch:';
    procedure searchDisplayController_didLoadSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:didLoadSearchResultsTableView:';
    procedure searchDisplayController_willUnloadSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:willUnloadSearchResultsTableView:';
    procedure searchDisplayController_willShowSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:willShowSearchResultsTableView:';
    procedure searchDisplayController_didShowSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:didShowSearchResultsTableView:';
    procedure searchDisplayController_willHideSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:willHideSearchResultsTableView:';
    procedure searchDisplayController_didHideSearchResultsTableView (controller: UISearchDisplayController; tableView: UITableView); message 'searchDisplayController:didHideSearchResultsTableView:';
    function searchDisplayController_shouldReloadTableForSearchString (controller: UISearchDisplayController; searchString: NSString): boolean; message 'searchDisplayController:shouldReloadTableForSearchString:';
    function searchDisplayController_shouldReloadTableForSearchScope (controller: UISearchDisplayController; searchOption: NSInteger): boolean; message 'searchDisplayController:shouldReloadTableForSearchScope:';
  end;
{$endif}

