{ Parsed from UIKit.framework (iPhoneOS5.0) UITabBar.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef CLASSES}

type
  UITabBar = objcclass external (UIView)
  private
    _customizeView: UIView;
    _backgroundView: UIView;
    _delegate: UITabBarDelegateProtocol;
    _items: NSArray;
    _selectedItem: UITabBarItem;
    _customizationItems: NSArray;
    _tabBarFlags: bitpacked record
      case byte of
        0: (_anonbitfield__tabBarFlags0: cuint);
        1: (
          alertShown: 0..1;
          wasEnabled: 0..1;
          customized: 0..1;
          downButtonSentAction: 0..1;
          isLocked: 0..1;
          backgroundIsPattern: 0..1;
        );
      end;
    _buttonItems: NSArray;
    _hiddenItems: CFMutableArrayRef;
    _appearanceStorage: id;
  public
    procedure setDelegate(newValue: UITabBarDelegateProtocol); message 'setDelegate:';
    function delegate: UITabBarDelegateProtocol; message 'delegate';
    procedure setItems(newValue: NSArray); message 'setItems:';
    function items: NSArray; message 'items';
    procedure setSelectedItem(newValue: UITabBarItem); message 'setSelectedItem:';
    function selectedItem: UITabBarItem; message 'selectedItem';
    procedure setItems_animated (items_: NSArray; animated: boolean); message 'setItems:animated:';
    procedure beginCustomizingItems (items_: NSArray); message 'beginCustomizingItems:';
    function endCustomizingAnimated (animated: boolean): boolean; message 'endCustomizingAnimated:';
    function isCustomizing: boolean; message 'isCustomizing';
    procedure setTintColor(newValue: UIColor); message 'setTintColor:';
    function tintColor: UIColor; message 'tintColor';
    procedure setSelectedImageTintColor(newValue: UIColor); message 'setSelectedImageTintColor:';
    function selectedImageTintColor: UIColor; message 'selectedImageTintColor';
    procedure setBackgroundImage(newValue: UIImage); message 'setBackgroundImage:';
    function backgroundImage: UIImage; message 'backgroundImage';
    procedure setSelectionIndicatorImage(newValue: UIImage); message 'setSelectionIndicatorImage:';
    function selectionIndicatorImage: UIImage; message 'selectionIndicatorImage';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UITabBarDelegateProtocol = objcprotocol external name 'UITabBarDelegate'
  optional
    procedure tabBar_didSelectItem (tabBar: UITabBar; item: UITabBarItem); message 'tabBar:didSelectItem:';
    procedure tabBar_willBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:willBeginCustomizingItems:';
    procedure tabBar_didBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:didBeginCustomizingItems:';
    procedure tabBar_willEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:willEndCustomizingItems:changed:';
    procedure tabBar_didEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:didEndCustomizingItems:changed:';
  end;
{$endif}

