{ Parsed from UIKit.framework (iPhoneOS5.0) UITabBarController.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef CLASSES}

type
  UITabBarController = objcclass external (UIViewController, UITabBarDelegateProtocol, NSCodingProtocol)
  private
    _tabBar: UITabBar;
    _containerView: UIView;
    _viewControllerTransitionView: UIView;
    _tabBarItemsToViewControllers: id;
    _selectedViewController: UIViewController;
    _moreNavigationController: UINavigationController;
    _customizableViewControllers: NSArray;
    _delegate: UITabBarControllerDelegateProtocol;
    _selectedViewControllerDuringWillAppear: UIViewController;
    _transientViewController: UIViewController;
    _maxItems: NSUInteger;
    _tabBarControllerFlags: bitpacked record
      case byte of
        0: (_anonbitfield__tabBarControllerFlags0: cuint);
        1: (
          isShowingMoreItem: 0..1;
          needsToRebuildItems: 0..1;
          isBarHidden: 0..1;
          editButtonOnLeft: 0..1;
        );
      end;
  public
    procedure setViewControllers(newValue: NSArray); message 'setViewControllers:';
    function viewControllers: NSArray; message 'viewControllers';
    procedure setViewControllers_animated (viewControllers_: NSArray; animated: boolean); message 'setViewControllers:animated:';
    procedure setSelectedViewController(newValue: UIViewController); message 'setSelectedViewController:';
    function selectedViewController: UIViewController; message 'selectedViewController';
    procedure setSelectedIndex(newValue: NSUInteger); message 'setSelectedIndex:';
    function selectedIndex: NSUInteger; message 'selectedIndex';
    function moreNavigationController: UINavigationController; message 'moreNavigationController';
    procedure setCustomizableViewControllers(newValue: NSArray); message 'setCustomizableViewControllers:';
    function customizableViewControllers: NSArray; message 'customizableViewControllers';
    function tabBar: UITabBar; message 'tabBar';
    procedure setDelegate(newValue: UITabBarControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UITabBarControllerDelegateProtocol; message 'delegate';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    procedure tabBar_didSelectItem (tabBar: UITabBar; item: UITabBarItem); message 'tabBar:didSelectItem:';
    procedure tabBar_didBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:didBeginCustomizingItems:';
    procedure tabBar_willBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:willBeginCustomizingItems:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure tabBar_didEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:didEndCustomizingItems:changed:';
    procedure tabBar_willEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:willEndCustomizingItems:changed:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UITabBarControllerDelegateProtocol = objcprotocol external name 'UITabBarControllerDelegate'
  optional
    function tabBarController_shouldSelectViewController (tabBarController: UITabBarController; viewController: UIViewController): boolean; message 'tabBarController:shouldSelectViewController:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure tabBarController_didSelectViewController (tabBarController: UITabBarController; viewController: UIViewController); message 'tabBarController:didSelectViewController:';
    procedure tabBarController_willBeginCustomizingViewControllers (tabBarController: UITabBarController; viewControllers: NSArray); message 'tabBarController:willBeginCustomizingViewControllers:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure tabBarController_willEndCustomizingViewControllers_changed (tabBarController: UITabBarController; viewControllers: NSArray; changed: boolean); message 'tabBarController:willEndCustomizingViewControllers:changed:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure tabBarController_didEndCustomizingViewControllers_changed (tabBarController: UITabBarController; viewControllers: NSArray; changed: boolean); message 'tabBarController:didEndCustomizingViewControllers:changed:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UIViewController_UITabBarControllerItem = objccategory external name 'UITabBarControllerItem' (UIViewController)
    procedure setTabBarItem(newValue: UITabBarItem); message 'setTabBarItem:';
    function tabBarItem: UITabBarItem; message 'tabBarItem';
    function tabBarController: UITabBarController; message 'tabBarController';
  end;
{$endif}

