{ Parsed from UIKit.framework (iPhoneOS5.0) UITableViewCell.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UITableViewCellStyleDefault = 0;
  UITableViewCellStyleValue1 = 1;
  UITableViewCellStyleValue2 = 2;
  UITableViewCellStyleSubtitle = 3;
type
  UITableViewCellStyle = clong;
const
  UITableViewCellSeparatorStyleNone = 0;
  UITableViewCellSeparatorStyleSingleLine = 1;
  UITableViewCellSeparatorStyleSingleLineEtched = 2;
type
  UITableViewCellSeparatorStyle = clong;
const
  UITableViewCellSelectionStyleNone = 0;
  UITableViewCellSelectionStyleBlue = 1;
  UITableViewCellSelectionStyleGray = 2;
type
  UITableViewCellSelectionStyle = clong;
const
  UITableViewCellEditingStyleNone = 0;
  UITableViewCellEditingStyleDelete = 1;
  UITableViewCellEditingStyleInsert = 2;
type
  UITableViewCellEditingStyle = clong;
const
  UITableViewCellAccessoryNone = 0;
  UITableViewCellAccessoryDisclosureIndicator = 1;
  UITableViewCellAccessoryDetailDisclosureButton = 2;
  UITableViewCellAccessoryCheckmark = 3;
type
  UITableViewCellAccessoryType = clong;
const
  UITableViewCellStateDefaultMask = 0;
  UITableViewCellStateShowingEditControlMask = 1 shl 0;
  UITableViewCellStateShowingDeleteConfirmationMask = 1 shl 1;

type
  UITableViewCellStateMask = NSUInteger;
  UITableViewCellStateMaskPtr = ^UITableViewCellStateMask;

const
  UITableViewCellStateEditingMask = UITableViewCellStateShowingEditControlMask;
{$endif}

{$ifdef CLASSES}

type
  UITableViewCell = objcclass external (UIView, NSCodingProtocol, UIGestureRecognizerDelegateProtocol)
  private
    _tableView: UITableView;
    _layoutManager: id;
    _target: id;
    _editAction: SEL;
    _accessoryAction: SEL;
    _oldEditingData: id;
    _editingData: id;
    _rightMargin: CGFloat;
    _indentationLevel: NSInteger;
    _indentationWidth: CGFloat;
    _reuseIdentifier: NSString;
    _contentView: UIView;
    _imageView: UIImageView;
    _textLabel: UILabel;
    _detailTextLabel: UILabel;
    _backgroundView: UIView;
    _selectedBackgroundView: UIView;
    _multipleSelectionBackgroundView: UIView;
    _selectedOverlayView: UIView;
    _selectionFadeDuration: CGFloat;
    _backgroundColor: UIColor;
    _separatorColor: UIColor;
    _topShadowColor: UIColor;
    _bottomShadowColor: UIColor;
    _sectionBorderColor: UIColor;
    _floatingSeparatorView: UIView;
    _topShadowAnimationView: UIView;
    _bottomShadowAnimationView: UIView;
    _unhighlightedStates: CFMutableDictionaryRef;
    _selectionSegueTemplate: id;
    _tableCellFlags: bitpacked record
      case byte of
        0: (_anonbitfield__tableCellFlags0: cuint);
        1: (
          showingDeleteConfirmation: 0..1;
          separatorStyle: 0..((1 shl 3)-1);
          selectionStyle: 0..((1 shl 3)-1);
          selectionFadeFraction: 0..((1 shl 11)-1);
          editing: 0..1;
          editingStyle: 0..((1 shl 3)-1);
          accessoryType: 0..((1 shl 3)-1);
          editingAccessoryType: 0..((1 shl 3)-1);
          showsAccessoryWhenEditing: 0..1;
          showsReorderControl: 0..1;
          showDisclosure: 0..1;
          showTopSeparator: 0..1;
          hideTopSeparatorDuringReordering: 0..1;
          disclosureClickable: 0..1;
          disclosureStyle: 0..1;
          showingRemoveControl: 0..1;
          sectionLocation: 0..((1 shl 3)-1);
          tableViewStyle: 0..1;
          shouldIndentWhileEditing: 0..1;
          fontSet: 0..1;
          usingDefaultSelectedBackgroundView: 0..1;
          wasSwiped: 0..1;
          highlighted: 0..1;
          separatorDirty: 0..1;
          drawn: 0..1;
          drawingDisabled: 0..1;
          style: 0..((1 shl 12)-1);
          showingMenu: 0..1;
          clipsContents: 0..1;
          animatingSelection: 0..1;
          backgroundColorSet: 0..1;
          needsSetup: 0..1;
          dontDrawTopShadow: 0..1;
          usingMultiselectbackgroundView: 0..1;
          layoutLoopCounter: 0..((1 shl 2)-1);
        );
      end;
    _accessoryView: UIButton;
    _editingAccessoryView: UIButton;
    _customAccessoryView: UIView;
    _customEditingAccessoryView: UIView;
    _separatorView: UIView;
    _topSeparatorView: UIView;
    _topShadowView: UIView;
    _editableTextField: UITextField;
    _lastSelectionTime: CFAbsoluteTime;
    _deselectTimer: NSTimer;
    _textFieldOffset: CGFloat;
    _returnAction: SEL;
    _selectionTintColor: UIColor;
    _accessoryTintColor: UIColor;
    _reorderControlImage: UIImage;
  public
    function initWithStyle_reuseIdentifier (style: UITableViewCellStyle; reuseIdentifier: NSString): id; message 'initWithStyle:reuseIdentifier:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    function imageView: UIImageView; message 'imageView';
    function textLabel: UILabel; message 'textLabel';
    function detailTextLabel: UILabel; message 'detailTextLabel';
    function contentView: UIView; message 'contentView';
    procedure setBackgroundView(newValue: UIView); message 'setBackgroundView:';
    function backgroundView: UIView; message 'backgroundView';
    procedure setSelectedBackgroundView(newValue: UIView); message 'setSelectedBackgroundView:';
    function selectedBackgroundView: UIView; message 'selectedBackgroundView';
    procedure setMultipleSelectionBackgroundView(newValue: UIView); message 'setMultipleSelectionBackgroundView:';
    function multipleSelectionBackgroundView: UIView; message 'multipleSelectionBackgroundView';
    function reuseIdentifier: NSString; message 'reuseIdentifier';
    procedure prepareForReuse; message 'prepareForReuse';
    procedure setSelectionStyle(newValue: UITableViewCellSelectionStyle); message 'setSelectionStyle:';
    function selectionStyle: UITableViewCellSelectionStyle; message 'selectionStyle';
    procedure setSelected(newValue: boolean); message 'setSelected:';
    function isSelected: boolean; message 'isSelected';
    procedure setHighlighted(newValue: boolean); message 'setHighlighted:';
    function isHighlighted: boolean; message 'isHighlighted';
    procedure setSelected_animated (selected: boolean; animated: boolean); message 'setSelected:animated:';
    procedure setHighlighted_animated (highlighted: boolean; animated: boolean); message 'setHighlighted:animated:';
    function editingStyle: UITableViewCellEditingStyle; message 'editingStyle';
    procedure setShowsReorderControl(newValue: boolean); message 'setShowsReorderControl:';
    function showsReorderControl: boolean; message 'showsReorderControl';
    procedure setShouldIndentWhileEditing(newValue: boolean); message 'setShouldIndentWhileEditing:';
    function shouldIndentWhileEditing: boolean; message 'shouldIndentWhileEditing';
    procedure setAccessoryType(newValue: UITableViewCellAccessoryType); message 'setAccessoryType:';
    function accessoryType: UITableViewCellAccessoryType; message 'accessoryType';
    procedure setAccessoryView(newValue: UIView); message 'setAccessoryView:';
    function accessoryView: UIView; message 'accessoryView';
    procedure setEditingAccessoryType(newValue: UITableViewCellAccessoryType); message 'setEditingAccessoryType:';
    function editingAccessoryType: UITableViewCellAccessoryType; message 'editingAccessoryType';
    procedure setEditingAccessoryView(newValue: UIView); message 'setEditingAccessoryView:';
    function editingAccessoryView: UIView; message 'editingAccessoryView';
    procedure setIndentationLevel(newValue: NSInteger); message 'setIndentationLevel:';
    function indentationLevel: NSInteger; message 'indentationLevel';
    procedure setIndentationWidth(newValue: CGFloat); message 'setIndentationWidth:';
    function indentationWidth: CGFloat; message 'indentationWidth';
    procedure setEditing(newValue: boolean); message 'setEditing:';
    function isEditing: boolean; message 'isEditing';
    procedure setEditing_animated (editing: boolean; animated: boolean); message 'setEditing:animated:';
    function showingDeleteConfirmation: boolean; message 'showingDeleteConfirmation';
    procedure willTransitionToState (state: UITableViewCellStateMask); message 'willTransitionToState:'; { available starting in __MAC_NA,__IPHONE_3_0 }
    procedure didTransitionToState (state: UITableViewCellStateMask); message 'didTransitionToState:'; { available starting in __MAC_NA,__IPHONE_3_0 }

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function gestureRecognizerShouldBegin (gestureRecognizer: UIGestureRecognizer): boolean; message 'gestureRecognizerShouldBegin:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function gestureRecognizer_shouldRecognizeSimultaneouslyWithGestureRecognizer (gestureRecognizer: UIGestureRecognizer; otherGestureRecognizer: UIGestureRecognizer): boolean; message 'gestureRecognizer:shouldRecognizeSimultaneouslyWithGestureRecognizer:';
    function gestureRecognizer_shouldReceiveTouch (gestureRecognizer: UIGestureRecognizer; touch: UITouch): boolean; message 'gestureRecognizer:shouldReceiveTouch:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
  end;


type
  UITableViewCell_UIDeprecated = objccategory external name 'UIDeprecated' (UITableViewCell)
    function initWithFrame_reuseIdentifier (frame_: CGRect; reuseIdentifier_: NSString): id; message 'initWithFrame:reuseIdentifier:'; deprecated 'in __MAC_NA,__MAC_NA,__IPHONE_2_0,__IPHONE_3_0';
    procedure setText(newValue: NSString); message 'setText:';
    function text: NSString; message 'text';
    procedure setFont(newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setTextAlignment(newValue: UITextAlignment); message 'setTextAlignment:';
    function textAlignment: UITextAlignment; message 'textAlignment';
    procedure setLineBreakMode(newValue: UILineBreakMode); message 'setLineBreakMode:';
    function lineBreakMode: UILineBreakMode; message 'lineBreakMode';
    procedure setTextColor(newValue: UIColor); message 'setTextColor:';
    function textColor: UIColor; message 'textColor';
    procedure setSelectedTextColor(newValue: UIColor); message 'setSelectedTextColor:';
    function selectedTextColor: UIColor; message 'selectedTextColor';
    procedure setImage(newValue: UIImage); message 'setImage:';
    function image: UIImage; message 'image';
    procedure setSelectedImage(newValue: UIImage); message 'setSelectedImage:';
    function selectedImage: UIImage; message 'selectedImage';
    procedure setHidesAccessoryWhenEditing(newValue: boolean); message 'setHidesAccessoryWhenEditing:';
    function hidesAccessoryWhenEditing: boolean; message 'hidesAccessoryWhenEditing';
    procedure setTarget(newValue: id); message 'setTarget:';
    function target: id; message 'target';
    procedure setEditAction(newValue: SEL); message 'setEditAction:';
    function editAction: SEL; message 'editAction';
    procedure setAccessoryAction(newValue: SEL); message 'setAccessoryAction:';
    function accessoryAction: SEL; message 'accessoryAction';
  end;
{$endif}

