{ Parsed from UIKit.framework (iPhoneOS5.0) UITextField.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UITextBorderStyleNone = 0;
  UITextBorderStyleLine = 1;
  UITextBorderStyleBezel = 2;
  UITextBorderStyleRoundedRect = 3;
type
  UITextBorderStyle = clong;
const
  UITextFieldViewModeNever = 0;
  UITextFieldViewModeWhileEditing = 1;
  UITextFieldViewModeUnlessEditing = 2;
  UITextFieldViewModeAlways = 3;
type
  UITextFieldViewMode = clong;
{$endif}

{$ifdef CLASSES}

type
  UITextField = objcclass external (UIControl, UITextInputProtocol, NSCodingProtocol)
  private
    _text: NSString;
    _textColor: UIColor;
    _borderStyle: UITextBorderStyle;
    _minimumFontSize: CGFloat;
    _delegate: id;
    _background: UIImage;
    _disabledBackground: UIImage;
    _clearButtonMode: UITextFieldViewMode;
    _leftView: UIView;
    _leftViewMode: UITextFieldViewMode;
    _rightView: UIView;
    _rightViewMode: UITextFieldViewMode;
    _traits: UITextInputTraits;
    _nonAtomTraits: UITextInputTraits;
    _fullFontSize: CGFloat;
    _paddingLeft: CGFloat;
    _paddingTop: CGFloat;
    _paddingRight: CGFloat;
    _paddingBottom: CGFloat;
    _textFont: NSString;
    _selectionRange: NSRange;
    _scrollXOffset: cint;
    _scrollYOffset: cint;
    _suffixWidth: cint;
    _progress: single;
    _style: NSString;
    _mouseDownTime: CFTimeInterval;
    _clearButton: UIButton;
    _clearButtonOffset: CGSize;
    _leftViewOffset: CGSize;
    _rightViewOffset: CGSize;
    _backgroundView: UITextFieldBorderView;
    _disabledBackgroundView: UITextFieldBorderView;
    _systemBackgroundView: UITextFieldBackgroundView;
    _textLabel: UITextFieldLabel;
    _placeholderLabel: UITextFieldLabel;
    _suffixLabel: UITextFieldLabel;
    _prefixLabel: UITextFieldLabel;
    _iconView: UIImageView;
    _label: UILabel;
    _labelOffset: CGFloat;
    _interactionAssistant: UITextInteractionAssistant;
    _selectionView: UITextSelectionView;
    _inputView: UIView;
    _inputAccessoryView: UIView;
    _atomBackgroundView: UITextFieldAtomBackgroundView;
    _definitionPopoverController: UIPopoverController;
    _definitionModalViewController: UIViewController;
    _textFieldFlags: bitpacked record
      case byte of
        0: (_anonbitfield__textFieldFlags0: cuint);
        1: (
          secureTextChanged: 0..1;
          guard: 0..1;
          delegateRespondsToHandleKeyDown: 0..1;
          verticallyCenterText: 0..1;
          isAnimating: 0..((1 shl 4)-1);
          inactiveHasDimAppearance: 0..1;
          becomesFirstResponderOnClearButtonTap: 0..1;
          clearsOnBeginEditing: 0..1;
          clearsPlaceholderOnBeginEditing: 0..1;
          adjustsFontSizeToFitWidth: 0..1;
          fieldEditorAttached: 0..1;
          canBecomeFirstResponder: 0..1;
          shouldSuppressShouldBeginEditing: 0..1;
          inResignFirstResponder: 0..1;
          undoDisabled: 0..1;
          contentsRTL: 0..1;
          explicitAlignment: 0..1;
          implementsCustomDrawing: 0..1;
          needsClearing: 0..1;
        );
      end;
  public
    procedure setText(newValue: NSString); message 'setText:';
    function text: NSString; message 'text';
    procedure setTextColor(newValue: UIColor); message 'setTextColor:';
    function textColor: UIColor; message 'textColor';
    procedure setFont(newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setTextAlignment(newValue: UITextAlignment); message 'setTextAlignment:';
    function textAlignment: UITextAlignment; message 'textAlignment';
    procedure setBorderStyle(newValue: UITextBorderStyle); message 'setBorderStyle:';
    function borderStyle: UITextBorderStyle; message 'borderStyle';
    procedure setPlaceholder(newValue: NSString); message 'setPlaceholder:';
    function placeholder: NSString; message 'placeholder';
    procedure setClearsOnBeginEditing(newValue: boolean); message 'setClearsOnBeginEditing:';
    function clearsOnBeginEditing: boolean; message 'clearsOnBeginEditing';
    procedure setAdjustsFontSizeToFitWidth(newValue: boolean); message 'setAdjustsFontSizeToFitWidth:';
    function adjustsFontSizeToFitWidth: boolean; message 'adjustsFontSizeToFitWidth';
    procedure setMinimumFontSize(newValue: CGFloat); message 'setMinimumFontSize:';
    function minimumFontSize: CGFloat; message 'minimumFontSize';
    procedure setDelegate(newValue: UITextFieldDelegateProtocol); message 'setDelegate:';
    function delegate: UITextFieldDelegateProtocol; message 'delegate';
    procedure setBackground(newValue: UIImage); message 'setBackground:';
    function background: UIImage; message 'background';
    procedure setDisabledBackground(newValue: UIImage); message 'setDisabledBackground:';
    function disabledBackground: UIImage; message 'disabledBackground';
    function isEditing: boolean; message 'isEditing';
    procedure setClearButtonMode(newValue: UITextFieldViewMode); message 'setClearButtonMode:';
    function clearButtonMode: UITextFieldViewMode; message 'clearButtonMode';
    procedure setLeftView(newValue: UIView); message 'setLeftView:';
    function leftView: UIView; message 'leftView';
    procedure setLeftViewMode(newValue: UITextFieldViewMode); message 'setLeftViewMode:';
    function leftViewMode: UITextFieldViewMode; message 'leftViewMode';
    procedure setRightView(newValue: UIView); message 'setRightView:';
    function rightView: UIView; message 'rightView';
    procedure setRightViewMode(newValue: UITextFieldViewMode); message 'setRightViewMode:';
    function rightViewMode: UITextFieldViewMode; message 'rightViewMode';
    function borderRectForBounds (bounds: CGRect): CGRect; message 'borderRectForBounds:';
    function textRectForBounds (bounds: CGRect): CGRect; message 'textRectForBounds:';
    function placeholderRectForBounds (bounds: CGRect): CGRect; message 'placeholderRectForBounds:';
    function editingRectForBounds (bounds: CGRect): CGRect; message 'editingRectForBounds:';
    function clearButtonRectForBounds (bounds: CGRect): CGRect; message 'clearButtonRectForBounds:';
    function leftViewRectForBounds (bounds: CGRect): CGRect; message 'leftViewRectForBounds:';
    function rightViewRectForBounds (bounds: CGRect): CGRect; message 'rightViewRectForBounds:';
    procedure drawTextInRect (rect: CGRect); message 'drawTextInRect:';
    procedure drawPlaceholderInRect (rect: CGRect); message 'drawPlaceholderInRect:';
    procedure setInputView(newValue: UIView); message 'setInputView:';
    function inputView: UIView; message 'inputView';
    procedure setInputAccessoryView(newValue: UIView); message 'setInputAccessoryView:';
    function inputAccessoryView: UIView; message 'inputAccessoryView';

    { Adopted protocols }
    function hash: NSUInteger; message 'hash';
    procedure setMarkedTextStyle(newValue: NSDictionary); message 'setMarkedTextStyle:';
    function markedTextStyle: NSDictionary; message 'markedTextStyle';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    procedure setInputDelegate(newValue: UITextInputDelegateProtocol); message 'setInputDelegate:';
    function inputDelegate: UITextInputDelegateProtocol; message 'inputDelegate';
    function tokenizer: UITextInputTokenizerProtocol; message 'tokenizer';
    function retainCount: NSUInteger; message 'retainCount';
    function beginningOfDocument: UITextPosition; message 'beginningOfDocument';
    function zone: NSZone; message 'zone';
    function hasText: boolean; message 'hasText';
    function autorelease: id; message 'autorelease';
    function self_: id; message 'self';
    function endOfDocument: UITextPosition; message 'endOfDocument';
    function isProxy: boolean; message 'isProxy';
    function markedTextRange: UITextRange; message 'markedTextRange';
    procedure setSelectedTextRange(newValue: UITextRange); message 'setSelectedTextRange:';
    function selectedTextRange: UITextRange; message 'selectedTextRange';
    function retain: id; message 'retain';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    procedure deleteBackward; message 'deleteBackward';
    procedure unmarkText; message 'unmarkText';
    procedure setReturnKeyType(newValue: UIReturnKeyType); message 'setReturnKeyType:';
    function returnKeyType: UIReturnKeyType; message 'returnKeyType';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    procedure setKeyboardAppearance(newValue: UIKeyboardAppearance); message 'setKeyboardAppearance:';
    function keyboardAppearance: UIKeyboardAppearance; message 'keyboardAppearance';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    procedure setAutocapitalizationType(newValue: UITextAutocapitalizationType); message 'setAutocapitalizationType:';
    function autocapitalizationType: UITextAutocapitalizationType; message 'autocapitalizationType';
    procedure setSpellCheckingType(newValue: UITextSpellCheckingType); message 'setSpellCheckingType:';
    function spellCheckingType: UITextSpellCheckingType; message 'spellCheckingType';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    procedure setAutocorrectionType(newValue: UITextAutocorrectionType); message 'setAutocorrectionType:';
    function autocorrectionType: UITextAutocorrectionType; message 'autocorrectionType';
    function characterRangeAtPoint (point: CGPoint): UITextRange; message 'characterRangeAtPoint:';
    procedure setKeyboardType(newValue: UIKeyboardType); message 'setKeyboardType:';
    function keyboardType: UIKeyboardType; message 'keyboardType';
    procedure setSelectionAffinity(newValue: UITextStorageDirection); message 'setSelectionAffinity:';
    function selectionAffinity: UITextStorageDirection; message 'selectionAffinity';
    function textInputView: UIView; message 'textInputView';
    procedure setEnablesReturnKeyAutomatically(newValue: boolean); message 'setEnablesReturnKeyAutomatically:';
    function enablesReturnKeyAutomatically: boolean; message 'enablesReturnKeyAutomatically';
    procedure setSecureTextEntry(newValue: boolean); message 'setSecureTextEntry:';
    function isSecureTextEntry: boolean; message 'isSecureTextEntry';
    function closestPositionToPoint (point: CGPoint): UITextPosition; message 'closestPositionToPoint:';
    function caretRectForPosition (position: UITextPosition): CGRect; message 'caretRectForPosition:';
    function firstRectForRange (range: UITextRange): CGRect; message 'firstRectForRange:';
    function textInRange (range: UITextRange): NSString; message 'textInRange:';
    procedure insertText (text: NSString); message 'insertText:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function offsetFromPosition_toPosition (from: UITextPosition; toPosition: UITextPosition): NSInteger; message 'offsetFromPosition:toPosition:';
    function textRangeFromPosition_toPosition (fromPosition: UITextPosition; toPosition: UITextPosition): UITextRange; message 'textRangeFromPosition:toPosition:';
    procedure setMarkedText_selectedRange (markedText: NSString; selectedRange: NSRange); message 'setMarkedText:selectedRange:';
    function closestPositionToPoint_withinRange (point: CGPoint; range: UITextRange): UITextPosition; message 'closestPositionToPoint:withinRange:';
    function baseWritingDirectionForPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): UITextWritingDirection; message 'baseWritingDirectionForPosition:inDirection:';
    function characterOffsetOfPosition_withinRange (position: UITextPosition; range: UITextRange): NSInteger; message 'characterOffsetOfPosition:withinRange:';
    function characterRangeByExtendingPosition_inDirection (position: UITextPosition; direction: UITextLayoutDirection): UITextRange; message 'characterRangeByExtendingPosition:inDirection:';
    function comparePosition_toPosition (position: UITextPosition; other: UITextPosition): NSComparisonResult; message 'comparePosition:toPosition:';
    function positionFromPosition_offset (position: UITextPosition; offset: NSInteger): UITextPosition; message 'positionFromPosition:offset:';
    function textStylingAtPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): NSDictionary; message 'textStylingAtPosition:inDirection:';
    function positionWithinRange_farthestInDirection (range: UITextRange; direction: UITextLayoutDirection): UITextPosition; message 'positionWithinRange:farthestInDirection:';
    function positionWithinRange_atCharacterOffset (range: UITextRange; offset: NSInteger): UITextPosition; message 'positionWithinRange:atCharacterOffset:';
    procedure replaceRange_withText (range: UITextRange; text: NSString); message 'replaceRange:withText:';
    procedure setBaseWritingDirection_forRange (writingDirection: UITextWritingDirection; range: UITextRange); message 'setBaseWritingDirection:forRange:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    function positionFromPosition_inDirection_offset (position: UITextPosition; direction: UITextLayoutDirection; offset: NSInteger): UITextPosition; message 'positionFromPosition:inDirection:offset:';
  end;


type
  UIView_UITextField = objccategory external name 'UITextField' (UIView)
    function endEditing (force: boolean): boolean; message 'endEditing:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UITextFieldDelegateProtocol = objcprotocol external name 'UITextFieldDelegate'
  optional
    function textFieldShouldBeginEditing (textField: UITextField): boolean; message 'textFieldShouldBeginEditing:';
    procedure textFieldDidBeginEditing (textField: UITextField); message 'textFieldDidBeginEditing:';
    function textFieldShouldEndEditing (textField: UITextField): boolean; message 'textFieldShouldEndEditing:';
    procedure textFieldDidEndEditing (textField: UITextField); message 'textFieldDidEndEditing:';
    function textField_shouldChangeCharactersInRange_replacementString (textField: UITextField; range: NSRange; string_: NSString): boolean; message 'textField:shouldChangeCharactersInRange:replacementString:';
    function textFieldShouldClear (textField: UITextField): boolean; message 'textFieldShouldClear:';
    function textFieldShouldReturn (textField: UITextField): boolean; message 'textFieldShouldReturn:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UITextFieldTextDidBeginEditingNotification: NSString; cvar; external;
  UITextFieldTextDidEndEditingNotification: NSString; cvar; external;
  UITextFieldTextDidChangeNotification: NSString; cvar; external;
{$endif}

