{ Parsed from UIKit.framework (iPhoneOS5.0) UITextInput.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef PROTOCOLS}

type
  UIKeyInputProtocol = objcprotocol external name 'UIKeyInput'
    function hasText: boolean; message 'hasText';
    procedure insertText (text: NSString); message 'insertText:';
    procedure deleteBackward; message 'deleteBackward';
  end;
{$endif}

{$ifdef TYPES}
const
  UITextStorageDirectionForward = 0;
  UITextStorageDirectionBackward = 1;
type
  UITextStorageDirection = clong;
const
  UITextLayoutDirectionRight = 2;
  UITextLayoutDirectionLeft = 3;
  UITextLayoutDirectionUp = 4;
  UITextLayoutDirectionDown = 5;
type
  UITextLayoutDirection = clong;

type
  UITextDirection = NSInteger;
  UITextDirectionPtr = ^UITextDirection;

const
  UITextWritingDirectionNatural = -1;
  UITextWritingDirectionLeftToRight = 0;
  UITextWritingDirectionRightToLeft = 1;
type
  UITextWritingDirection = clong;
const
  UITextGranularityCharacter = 0;
  UITextGranularityWord = 1;
  UITextGranularitySentence = 2;
  UITextGranularityParagraph = 3;
  UITextGranularityLine = 4;
  UITextGranularityDocument = 5;
type
  UITextGranularity = clong;
{$endif}

{$ifdef PROTOCOLS}

type
  UITextInputProtocol = objcprotocol external name 'UITextInput'
  required
    function textInRange (range: UITextRange): NSString; message 'textInRange:';
    procedure replaceRange_withText (range: UITextRange; text: NSString); message 'replaceRange:withText:';
    procedure setSelectedTextRange(newValue: UITextRange); message 'setSelectedTextRange:';
    function selectedTextRange: UITextRange; message 'selectedTextRange';
    function markedTextRange: UITextRange; message 'markedTextRange';
    procedure setMarkedTextStyle(newValue: NSDictionary); message 'setMarkedTextStyle:';
    function markedTextStyle: NSDictionary; message 'markedTextStyle';
    procedure setMarkedText_selectedRange (markedText: NSString; selectedRange: NSRange); message 'setMarkedText:selectedRange:';
    procedure unmarkText; message 'unmarkText';
    function beginningOfDocument: UITextPosition; message 'beginningOfDocument';
    function endOfDocument: UITextPosition; message 'endOfDocument';
    function textRangeFromPosition_toPosition (fromPosition: UITextPosition; toPosition: UITextPosition): UITextRange; message 'textRangeFromPosition:toPosition:';
    function positionFromPosition_offset (position: UITextPosition; offset: NSInteger): UITextPosition; message 'positionFromPosition:offset:';
    function positionFromPosition_inDirection_offset (position: UITextPosition; direction: UITextLayoutDirection; offset: NSInteger): UITextPosition; message 'positionFromPosition:inDirection:offset:';
    function comparePosition_toPosition (position: UITextPosition; other: UITextPosition): NSComparisonResult; message 'comparePosition:toPosition:';
    function offsetFromPosition_toPosition (from: UITextPosition; toPosition: UITextPosition): NSInteger; message 'offsetFromPosition:toPosition:';
    //procedure setInputDelegate(newValue: UITextInputDelegateProtocol); message 'setInputDelegate:';
    //function inputDelegate: UITextInputDelegateProtocol; message 'inputDelegate';
    //function tokenizer: UITextInputTokenizerProtocol; message 'tokenizer';
    function positionWithinRange_farthestInDirection (range: UITextRange; direction: UITextLayoutDirection): UITextPosition; message 'positionWithinRange:farthestInDirection:';
    function characterRangeByExtendingPosition_inDirection (position: UITextPosition; direction: UITextLayoutDirection): UITextRange; message 'characterRangeByExtendingPosition:inDirection:';
    function baseWritingDirectionForPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): UITextWritingDirection; message 'baseWritingDirectionForPosition:inDirection:';
    procedure setBaseWritingDirection_forRange (writingDirection: UITextWritingDirection; range: UITextRange); message 'setBaseWritingDirection:forRange:';
    function firstRectForRange (range: UITextRange): CGRect; message 'firstRectForRange:';
    function caretRectForPosition (position: UITextPosition): CGRect; message 'caretRectForPosition:';
    function closestPositionToPoint (point: CGPoint): UITextPosition; message 'closestPositionToPoint:';
    function closestPositionToPoint_withinRange (point: CGPoint; range: UITextRange): UITextPosition; message 'closestPositionToPoint:withinRange:';
    function characterRangeAtPoint (point: CGPoint): UITextRange; message 'characterRangeAtPoint:';
  optional
    function textStylingAtPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): NSDictionary; message 'textStylingAtPosition:inDirection:';
    function positionWithinRange_atCharacterOffset (range: UITextRange; offset: NSInteger): UITextPosition; message 'positionWithinRange:atCharacterOffset:';
    function characterOffsetOfPosition_withinRange (position: UITextPosition; range: UITextRange): NSInteger; message 'characterOffsetOfPosition:withinRange:';
    function textInputView: UIView; message 'textInputView';
    procedure setSelectionAffinity(newValue: UITextStorageDirection); message 'setSelectionAffinity:';
    function selectionAffinity: UITextStorageDirection; message 'selectionAffinity';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UITextInputTextBackgroundColorKey: NSString; cvar; external;
  UITextInputTextColorKey: NSString; cvar; external;
  UITextInputTextFontKey: NSString; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  UITextPosition = objcclass external (NSObject)
  end;

type
  UITextRange = objcclass external (NSObject)
  public
    function isEmpty: boolean; message 'isEmpty';
    function start: UITextPosition; message 'start';
    function end_: UITextPosition; message 'end';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UITextInputDelegateProtocol = objcprotocol external name 'UITextInputDelegate'
    procedure selectionWillChange (textInput: UITextInputProtocol); message 'selectionWillChange:';
    procedure selectionDidChange (textInput: UITextInputProtocol); message 'selectionDidChange:';
    procedure textWillChange (textInput: UITextInputProtocol); message 'textWillChange:';
    procedure textDidChange (textInput: UITextInputProtocol); message 'textDidChange:';
  end;

type
  UITextInputTokenizerProtocol = objcprotocol external name 'UITextInputTokenizer'
  required
    function rangeEnclosingPosition_withGranularity_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextRange; message 'rangeEnclosingPosition:withGranularity:inDirection:';
    function isPosition_atBoundary_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): boolean; message 'isPosition:atBoundary:inDirection:';
    function positionFromPosition_toBoundary_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextPosition; message 'positionFromPosition:toBoundary:inDirection:';
    function isPosition_withinTextUnit_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): boolean; message 'isPosition:withinTextUnit:inDirection:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UITextInputStringTokenizer = objcclass external (NSObject, UITextInputTokenizerProtocol)
  private
    _textInput: UITextInputProtocol;
  public
    function initWithTextInput (textInput: UITextInputProtocol): id; message 'initWithTextInput:';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    function isPosition_atBoundary_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): boolean; message 'isPosition:atBoundary:inDirection:';
    function isPosition_withinTextUnit_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): boolean; message 'isPosition:withinTextUnit:inDirection:';
    function positionFromPosition_toBoundary_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextPosition; message 'positionFromPosition:toBoundary:inDirection:';
    function rangeEnclosingPosition_withGranularity_inDirection (position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextRange; message 'rangeEnclosingPosition:withGranularity:inDirection:';
  end;

type
  UITextInputMode = objcclass external (NSObject)
  public
    function primaryLanguage: NSString; message 'primaryLanguage';
    class function currentInputMode: UITextInputMode; message 'currentInputMode';
    class function activeInputModes: NSArray; message 'activeInputModes';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UITextInputCurrentInputModeDidChangeNotification: NSString { available starting in __MAC_NA,__IPHONE_4_2 }; cvar; external;
{$endif}

