{ Parsed from UIKit.framework (iPhoneOS5.0) UITextView.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef PROTOCOLS}

type
  UITextViewDelegateProtocol = objcprotocol external name 'UITextViewDelegate'
  optional
    function textViewShouldBeginEditing (textView: UITextView): boolean; message 'textViewShouldBeginEditing:';
    function textViewShouldEndEditing (textView: UITextView): boolean; message 'textViewShouldEndEditing:';
    procedure textViewDidBeginEditing (textView: UITextView); message 'textViewDidBeginEditing:';
    procedure textViewDidEndEditing (textView: UITextView); message 'textViewDidEndEditing:';
    function textView_shouldChangeTextInRange_replacementText (textView: UITextView; range: NSRange; text: NSString): boolean; message 'textView:shouldChangeTextInRange:replacementText:';
    procedure textViewDidChange (textView: UITextView); message 'textViewDidChange:';
    procedure textViewDidChangeSelection (textView: UITextView); message 'textViewDidChangeSelection:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UITextView = objcclass external (UIScrollView, UITextInputProtocol)
  private
    m_frame: WebFrame;
    m_body: DOMHTMLElement;
    m_marginTop: cint;
    m_selectionTimer: UIDelayedAction;
    m_longPressAction: UIDelayedAction;
    m_editable: boolean;
    m_editing: boolean;
    m_becomesEditableWithGestures: boolean;
    m_reentrancyGuard: boolean;
    m_readyForScroll: boolean;
    m_hasExplicitTextAlignment: boolean;
    m_hasExplicitLineHeight: boolean;
    m_interactionAssistant: UITextInteractionAssistant;
    m_selectionView: UITextSelectionView;
    m_webView: UIWebDocumentView;
    m_font: UIFont;
    m_textColor: UIColor;
    m_textAlignment: UITextAlignment;
    m_inputView: UIView;
    m_inputAccessoryView: UIView;
    m_lineHeight: single;
    m_skipScrollContainingView: boolean;
  public
    procedure setDelegate_(newValue: UITextViewDelegateProtocol); message 'setDelegate:';
    function delegate_: UITextViewDelegateProtocol; message 'delegate';
    procedure setText(newValue: NSString); message 'setText:';
    function text: NSString; message 'text';
    procedure setFont(newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setTextColor(newValue: UIColor); message 'setTextColor:';
    function textColor: UIColor; message 'textColor';
    procedure setTextAlignment(newValue: UITextAlignment); message 'setTextAlignment:';
    function textAlignment: UITextAlignment; message 'textAlignment';
    procedure setSelectedRange(newValue: NSRange); message 'setSelectedRange:';
    function selectedRange: NSRange; message 'selectedRange';
    procedure setEditable(newValue: boolean); message 'setEditable:';
    function isEditable: boolean; message 'isEditable';
    procedure setDataDetectorTypes(newValue: UIDataDetectorTypes); message 'setDataDetectorTypes:';
    function dataDetectorTypes: UIDataDetectorTypes; message 'dataDetectorTypes';
    function hasText: boolean; message 'hasText';
    procedure scrollRangeToVisible (range: NSRange); message 'scrollRangeToVisible:';
    procedure setInputView(newValue: UIView); message 'setInputView:';
    function inputView: UIView; message 'inputView';
    procedure setInputAccessoryView(newValue: UIView); message 'setInputAccessoryView:';
    function inputAccessoryView: UIView; message 'inputAccessoryView';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    procedure setMarkedTextStyle(newValue: NSDictionary); message 'setMarkedTextStyle:';
    function markedTextStyle: NSDictionary; message 'markedTextStyle';
    function markedTextRange: UITextRange; message 'markedTextRange';
    function description: NSString; message 'description';
    function beginningOfDocument: UITextPosition; message 'beginningOfDocument';
    function endOfDocument: UITextPosition; message 'endOfDocument';
    function hash: NSUInteger; message 'hash';
    procedure setSelectedTextRange(newValue: UITextRange); message 'setSelectedTextRange:';
    function selectedTextRange: UITextRange; message 'selectedTextRange';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    procedure deleteBackward; message 'deleteBackward';
    function closestPositionToPoint (point: CGPoint): UITextPosition; message 'closestPositionToPoint:';
    function caretRectForPosition (position: UITextPosition): CGRect; message 'caretRectForPosition:';
    function textInRange (range: UITextRange): NSString; message 'textInRange:';
    procedure insertText (text: NSString); message 'insertText:';
    function offsetFromPosition_toPosition (from: UITextPosition; toPosition: UITextPosition): NSInteger; message 'offsetFromPosition:toPosition:';
    procedure setInputDelegate(newValue: UITextInputDelegateProtocol); message 'setInputDelegate:';
    function inputDelegate: UITextInputDelegateProtocol; message 'inputDelegate';
    function characterRangeAtPoint (point: CGPoint): UITextRange; message 'characterRangeAtPoint:';
    function tokenizer: UITextInputTokenizerProtocol; message 'tokenizer';
    function firstRectForRange (range: UITextRange): CGRect; message 'firstRectForRange:';
    function closestPositionToPoint_withinRange (point: CGPoint; range: UITextRange): UITextPosition; message 'closestPositionToPoint:withinRange:';
    procedure setKeyboardType(newValue: UIKeyboardType); message 'setKeyboardType:';
    function keyboardType: UIKeyboardType; message 'keyboardType';
    function baseWritingDirectionForPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): UITextWritingDirection; message 'baseWritingDirectionForPosition:inDirection:';
    function characterOffsetOfPosition_withinRange (position: UITextPosition; range: UITextRange): NSInteger; message 'characterOffsetOfPosition:withinRange:';
    function characterRangeByExtendingPosition_inDirection (position: UITextPosition; direction: UITextLayoutDirection): UITextRange; message 'characterRangeByExtendingPosition:inDirection:';
    function comparePosition_toPosition (position: UITextPosition; other: UITextPosition): NSComparisonResult; message 'comparePosition:toPosition:';
    function textStylingAtPosition_inDirection (position: UITextPosition; direction: UITextStorageDirection): NSDictionary; message 'textStylingAtPosition:inDirection:';
    function positionWithinRange_farthestInDirection (range: UITextRange; direction: UITextLayoutDirection): UITextPosition; message 'positionWithinRange:farthestInDirection:';
    procedure setKeyboardAppearance(newValue: UIKeyboardAppearance); message 'setKeyboardAppearance:';
    function keyboardAppearance: UIKeyboardAppearance; message 'keyboardAppearance';
    function positionWithinRange_atCharacterOffset (range: UITextRange; offset: NSInteger): UITextPosition; message 'positionWithinRange:atCharacterOffset:';
    procedure setBaseWritingDirection_forRange (writingDirection: UITextWritingDirection; range: UITextRange); message 'setBaseWritingDirection:forRange:';
    procedure setReturnKeyType(newValue: UIReturnKeyType); message 'setReturnKeyType:';
    function returnKeyType: UIReturnKeyType; message 'returnKeyType';
    procedure setAutocapitalizationType(newValue: UITextAutocapitalizationType); message 'setAutocapitalizationType:';
    function autocapitalizationType: UITextAutocapitalizationType; message 'autocapitalizationType';
    procedure setAutocorrectionType(newValue: UITextAutocorrectionType); message 'setAutocorrectionType:';
    function autocorrectionType: UITextAutocorrectionType; message 'autocorrectionType';
    function positionFromPosition_inDirection_offset (position: UITextPosition; direction: UITextLayoutDirection; offset: NSInteger): UITextPosition; message 'positionFromPosition:inDirection:offset:';
    procedure setSpellCheckingType(newValue: UITextSpellCheckingType); message 'setSpellCheckingType:';
    function spellCheckingType: UITextSpellCheckingType; message 'spellCheckingType';
    function retain: id; message 'retain';
    function textInputView: UIView; message 'textInputView';
    procedure setEnablesReturnKeyAutomatically(newValue: boolean); message 'setEnablesReturnKeyAutomatically:';
    function enablesReturnKeyAutomatically: boolean; message 'enablesReturnKeyAutomatically';
    procedure setSecureTextEntry(newValue: boolean); message 'setSecureTextEntry:';
    function isSecureTextEntry: boolean; message 'isSecureTextEntry';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    procedure setSelectionAffinity(newValue: UITextStorageDirection); message 'setSelectionAffinity:';
    function selectionAffinity: UITextStorageDirection; message 'selectionAffinity';
    procedure unmarkText; message 'unmarkText';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function textRangeFromPosition_toPosition (fromPosition: UITextPosition; toPosition: UITextPosition): UITextRange; message 'textRangeFromPosition:toPosition:';
    procedure setMarkedText_selectedRange (markedText: NSString; selectedRange: NSRange); message 'setMarkedText:selectedRange:';
    function positionFromPosition_offset (position: UITextPosition; offset: NSInteger): UITextPosition; message 'positionFromPosition:offset:';
    procedure replaceRange_withText (range: UITextRange; text: NSString); message 'replaceRange:withText:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UITextViewTextDidBeginEditingNotification: NSString; cvar; external;
  UITextViewTextDidChangeNotification: NSString; cvar; external;
  UITextViewTextDidEndEditingNotification: NSString; cvar; external;
{$endif}

