{ Parsed from UIKit.framework (iPhoneOS5.0) UIWebView.h }
{ Created on Tue Feb 7 7:54:47 2012 }

{$ifdef TYPES}
const
  UIWebViewNavigationTypeLinkClicked = 0;
  UIWebViewNavigationTypeFormSubmitted = 1;
  UIWebViewNavigationTypeBackForward = 2;
  UIWebViewNavigationTypeReload = 3;
  UIWebViewNavigationTypeFormResubmitted = 4;
  UIWebViewNavigationTypeOther = 5;
type
  UIWebViewNavigationType = clong;
{$endif}

{$ifdef CLASSES}

type
  UIWebView = objcclass external (UIView, NSCodingProtocol, UIScrollViewDelegateProtocol)
  private
    _internal: UIWebViewInternal;
  public
    procedure setDelegate(newValue: UIWebViewDelegateProtocol); message 'setDelegate:';
    function delegate: UIWebViewDelegateProtocol; message 'delegate';
    function scrollView: UIScrollView; message 'scrollView';
    procedure loadRequest (request: NSURLRequest); message 'loadRequest:';
    procedure loadHTMLString_baseURL (string_: NSString; baseURL: NSURL); message 'loadHTMLString:baseURL:';
    procedure loadData_MIMEType_textEncodingName_baseURL (data: NSData; MIMEType: NSString; textEncodingName: NSString; baseURL: NSURL); message 'loadData:MIMEType:textEncodingName:baseURL:';
    function request: NSURLRequest; message 'request';
    procedure reload; message 'reload';
    procedure stopLoading; message 'stopLoading';
    procedure goBack; message 'goBack';
    procedure goForward; message 'goForward';
    function canGoBack: boolean; message 'canGoBack';
    function canGoForward: boolean; message 'canGoForward';
    function isLoading: boolean; message 'isLoading';
    function stringByEvaluatingJavaScriptFromString (script: NSString): NSString; message 'stringByEvaluatingJavaScriptFromString:';
    procedure setScalesPageToFit(newValue: boolean); message 'setScalesPageToFit:';
    function scalesPageToFit: boolean; message 'scalesPageToFit';
    procedure setDetectsPhoneNumbers(newValue: boolean); message 'setDetectsPhoneNumbers:';
    function detectsPhoneNumbers: boolean; message 'detectsPhoneNumbers';
    procedure setDataDetectorTypes(newValue: UIDataDetectorTypes); message 'setDataDetectorTypes:';
    function dataDetectorTypes: UIDataDetectorTypes; message 'dataDetectorTypes';
    procedure setAllowsInlineMediaPlayback(newValue: boolean); message 'setAllowsInlineMediaPlayback:';
    function allowsInlineMediaPlayback: boolean; message 'allowsInlineMediaPlayback';
    procedure setMediaPlaybackRequiresUserAction(newValue: boolean); message 'setMediaPlaybackRequiresUserAction:';
    function mediaPlaybackRequiresUserAction: boolean; message 'mediaPlaybackRequiresUserAction';
    procedure setMediaPlaybackAllowsAirPlay(newValue: boolean); message 'setMediaPlaybackAllowsAirPlay:';
    function mediaPlaybackAllowsAirPlay: boolean; message 'mediaPlaybackAllowsAirPlay';

    { Adopted protocols }
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function retainCount: NSUInteger; message 'retainCount';
    function zone: NSZone; message 'zone';
    function isProxy: boolean; message 'isProxy';
    function autorelease: id; message 'autorelease';
    function retain: id; message 'retain';
    function self_: id; message 'self';
    function class_: pobjc_class; message 'class';
    function superclass: pobjc_class; message 'superclass';
    procedure release; message 'release';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function isEqual (object_: id): boolean; message 'isEqual:';
    procedure scrollViewDidEndDecelerating (scrollView: UIScrollView); message 'scrollViewDidEndDecelerating:';
    procedure scrollViewDidEndScrollingAnimation (scrollView: UIScrollView); message 'scrollViewDidEndScrollingAnimation:';
    procedure scrollViewDidScroll (scrollView: UIScrollView); message 'scrollViewDidScroll:';
    procedure scrollViewDidScrollToTop (scrollView: UIScrollView); message 'scrollViewDidScrollToTop:';
    procedure scrollViewDidZoom (scrollView: UIScrollView); message 'scrollViewDidZoom:'; { available starting in __MAC_NA,__IPHONE_3_2 }
    function scrollViewShouldScrollToTop (scrollView: UIScrollView): boolean; message 'scrollViewShouldScrollToTop:';
    procedure scrollViewWillBeginDecelerating (scrollView: UIScrollView); message 'scrollViewWillBeginDecelerating:';
    procedure scrollViewWillBeginDragging (scrollView: UIScrollView); message 'scrollViewWillBeginDragging:';
    function viewForZoomingInScrollView (scrollView: UIScrollView): UIView; message 'viewForZoomingInScrollView:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    procedure scrollViewDidEndDragging_willDecelerate (scrollView: UIScrollView; decelerate: boolean); message 'scrollViewDidEndDragging:willDecelerate:';
    procedure scrollViewWillBeginZooming_withView (scrollView: UIScrollView; view: UIView); message 'scrollViewWillBeginZooming:withView:'; { available starting in __MAC_NA,__IPHONE_3_2 }
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure scrollViewDidEndZooming_withView_atScale (scrollView: UIScrollView; view: UIView; scale: single); message 'scrollViewDidEndZooming:withView:atScale:';
    procedure scrollViewWillEndDragging_withVelocity_targetContentOffset (scrollView: UIScrollView; velocity: CGPoint; targetContentOffset: CGPointPtr); message 'scrollViewWillEndDragging:withVelocity:targetContentOffset:'; { available starting in __MAC_NA,__IPHONE_5_0 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIWebViewDelegateProtocol = objcprotocol external name 'UIWebViewDelegate'
  optional
    function webView_shouldStartLoadWithRequest_navigationType (webView: UIWebView; request: NSURLRequest; navigationType: UIWebViewNavigationType): boolean; message 'webView:shouldStartLoadWithRequest:navigationType:';
    procedure webViewDidStartLoad (webView: UIWebView); message 'webViewDidStartLoad:';
    procedure webViewDidFinishLoad (webView: UIWebView); message 'webViewDidFinishLoad:';
    procedure webView_didFailLoadWithError (webView: UIWebView; error: NSError); message 'webView:didFailLoadWithError:';
  end;
{$endif}

